CUI_CONFIG_SHOWN = false;

CUI_START_DELAY = 2;

-- Controls des Config UI
local controls = {};

-- saved variables
CleanUICommonData = {};

-- saved variables per character
CleanUIData = {};
CleanUIWayPoints = {};
CleanUITradeSkillQueue = {};
CleanUIContainerLock = {};

-- initial values
CleanUIData.VERSION = nil;

CleanUIData.EQUIPPED_SETNAME = nil;

CleanUIData.SCREENSHOT = 1;

CleanUIData.STATUSBAR_STYLE = 1;
CleanUIData.CUI_STATUSBAR = "Interface\\AddOns\\CleanUI\\skins\\StatusBar";
CleanUIData.CUI_STATUSBAR_VERTICAL = "Interface\\AddOns\\CleanUI\\skins\\StatusBarVertical";

CleanUIData.CHANGE_ACTIONBARS = 1;
CleanUIData.ACTIONBARS_SHOWMACRONAMES = 0;
CleanUIData.ACTIONBARS_ACTIONBUTTON_BORDER = 1;
CleanUIData.ACTIONBARS_SHAPESHIFTBAR_BORDER = 1;
CleanUIData.ACTIONBARS_PETACTIONBAR_BORDER = 1;
CleanUIData.MASQUE_ACTIONBUTTONS = 1; 
CleanUIData.ACTIONBARS_SHOWRANGEINDICATOR = 0;

CleanUIData.ACTIONBARS_DEBUFFS = 1;
CleanUIData.ACTIONBARS_DEBUFFS_R = 1;
CleanUIData.ACTIONBARS_DEBUFFS_G = 0;
CleanUIData.ACTIONBARS_DEBUFFS_B = 0;
CleanUIData.ACTIONBARS_DEBUFFS_HEIGHT = 2;
CleanUIData.MASQUE_BUFFS = 1;
CleanUIData.BIGGER_DEBUFFS = 1;

CleanUIData.CHANGE_BAGS = 1;
CleanUIData.BAGS_COLORIZE_ITEMS = 1;
CleanUIData.BAGS_SHOW_WHITE_AS_GRAY = 1;
CleanUIData.BAGS_AUTOREPAIR = 1;
CleanUIData.BAGS_AUTOSELLGRAY = 1;
CleanUIData.BAGPACK_MINIMAP_POS = 45;

CleanUIData.CHANGE_CASTINGBARS = 1;
CleanUIData.CASTINGBARS_SHOWPETBAR = 1;
CleanUIData.CASTINGBARS_ALPHA = 1;
CleanUIData.CASTINGBARS_WIDTH = 300;
CleanUIData.CASTINGBARS_PLAYERHEIGHT = 24;
CleanUIData.CASTINGBARS_IMAGESIZE = 24;
CleanUIData.CASTINGBARS_PETHEIGHT = 16;
CleanUIData.CASTINGBARS_GLOBALCOOLDOWN = 1;
CleanUIData.CASTINGBARS_GLOBALCOOLDOWN_HEIGHT = 2;
CleanUIData.CASTINGBARS_LATENCY = 1;

CleanUIData.CHANGE_MINIMAP = 1;
CleanUIData.MINIMAP_ALPHA = 1;
CleanUIData.WATCHFRAME_ALPHA = 0.75;
CleanUIData.MINIMAP_SHOWBUTTONBAR = 1;
CleanUIData.MINIMAP_RIGHTBUTTONS = {};
CleanUIData.MAP_SHOWQUESTLEVEL = 1;
CleanUIData.MAP_SHOWSHIPROUTES = 1;
CleanUIData.MAP_SHOWWAYPOINTS = 1;
CleanUIData.TLOC_R = 1;
CleanUIData.TLOC_G = 1;
CleanUIData.TLOC_B = 1;

CleanUIData.CHANGE_UNITFRAMES = 1;
CleanUIData.CHANGE_BOSSFRAMES = 1;
CleanUIData.PORTRAIT_STYLE = 1; 
CleanUIData.UNITFRAME_CUSTOM_POSITIONS = {};
CleanUIData.MONK_CHI_TEXTURE_INDEX = 14;
CleanUIData.MONK_CHI_TEXTURE = "chi_white";

CleanUIData.SHOW_XPFRAME = 0;
CleanUIData.SHOW_ORIG_XPBAR = 1;
CleanUIData.XPFRAME_WIDTH = 210;
CleanUIData.XPBAR_HEIGHT = 13;
CleanUIData.XPFRAME_X_XMAX = 1;
CleanUIData.XPFRAME_PERCENT = 1;
CleanUIData.XPFRAME_MAXLEVEL = 0;
CleanUIData.XPFRAME_UNKNOWN = 0;

CleanUIData.CHANGE_CHAT = 1;
CleanUIData.DISABLE_ALTARROWKEYMODE = 1;
CleanUIData.SHOW_CHAT_ACTIONBAR = 1;
CleanUIData.SHOW_CHAT_EMOTICONS = 1;
CleanUIData.CHAT_FONT_SIZE = 14;

CleanUIData.CHANGE_RAID = 1;
    
CleanUIData.TOOLTIPS_HIDEINCOMBAT = 0;
CleanUIData.TOOLTIPS_BACKDROP = 1;
CleanUIData.TOOLTIPS_POSITION = 1;

CleanUIData.CHANGE_NAMEPLATES = 1;
CleanUIData.NAMEPLATES_PERCENT = 1;
CleanUIData.NAMEPLATES_HIGHLIGHTTARGET = 1;
CleanUIData.NAMEPLATES_SHOWCOMBOPOINTS = 1;
CleanUIData.NAMEPLATES_COMBATONLY = 0;

CleanUIData.SHOW_DATABROKER = 1;
CleanUIData.DATABROKER_COUNTROWS = 2;

CleanUIData.DataBroker_Disabled = {};

CleanUIData.unitFramePositions = {};
CleanUIData.unitFramePositions["PlayerFrame"] = nil;
CleanUIData.unitFramePositions["TargetFrame"] = nil;
CleanUIData.unitFramePositions["FocusFrame"] = nil;

local STATUSBAR_STYLE = {
	"default",
	"Aluminium",
	"Bantobar",
	"Charcoal",
	"Flat",
	"Frost",
	"Glaze",
	"Healbot",
	"LiteStep",
	"Minimalist",
	"Otravi",
	"Perl",
	"Rocks",
	"Runes",
	"Smooth",
	"Smudge",
	"Striped",
	"SWS",
	"Xeon",
	"Xus",
}

local MONK_CHI_TEXTURES = {
    "white chi",
    "blue chi",
    "green chi",
    "red chi",
    "yellow chi",
    "turquoise chi",
    "gold yin yang",
    "blue yin yang",
    "green yin yang",
    "red yin yang",
    "yellow yin yang",
    "purple yin yang",
    "blue and gold yin yang",
    "blue and white yin yang",
    "blue and purple yin yang",
}

local PORTRAIT_TYPE = {
	PORTRAIT_TYPE_3D,
	PORTRAIT_TYPE_CLASSITEM,
}

local TOOLTIPS_POSITION = {
	CONFIG_TOOLTIP_POSITION_STANDARD,
	CONFIG_TOOLTIP_POSITION_MOUSEPOSITION,
	CONFIG_TOOLTIP_POSITION_TOP,
}

local FACTIONS = {
    FACTION_ALLIANCE,
    FACTION_HORDE,
    FACTION_OTHER,
    ALL,
    NONE,
}

function CleanUIConfig_OnLoad(self)
    CleanUIConfig_CreateUI(self);    
    CleanUIConfig_InitDataBroker();

    self:RegisterEvent("ADDON_LOADED");
    self:RegisterEvent("CVAR_UPDATE");
    
    hooksecurefunc(InterfaceOptionsFrame, "Show", CleanUIConfig_InterfaceOptionsFrame_Show);
    hooksecurefunc(InterfaceOptionsFrame, "Hide", CleanUIConfig_InterfaceOptionsFrame_Hide);
    
    cui_config_loaded = true;
end

function CleanUIConfig_CreateUI(self)
    
    -- Hauptfenster
    self.name="CleanUI";
    self.addonname = "CleanUI";
    InterfaceOptions_AddCategory(self);

    local author = GetAddOnMetadata("CleanUI", "Author");
    local version = GetAddOnMetadata("CleanUI", "Version");
    
    -- ConfigFrame
    CleanUIConfig_CreateHeader(self, "CleanUI v"..version , "("..author..")");
    
    CleanUIConfig_AddCheckButton(self, "CUIConfig_ToggleScreenshot",
                CONFIG_TOGGLESCREENSHOT, CleanUIConfig_ToggleScreenshot);
                
    CleanUIConfig_AddSlider(self, "CUIConfig_SelectWatchFrameAlpha",
                CONFIG_TOGGLEWATCHFRAMEALPHA, 0, 1, 0.01, CleanUIConfig_SelectWatchFrameAlpha);

    CleanUIConfig_AddDropDown(self, "CUIConfig_StatusBarStyleDropDown",
                CONFIG_STATUSBAR_STYLE, CUIConfig_StatusBarStyleDropDown_Initialize);
                
    CleanUIConfig_AddLabel(self, "CUIConfig_Load and Save", CONFIG_LOADSAVEPRESETS);
                
    CleanUIConfig_AddControl(self, CUIConfig_SaveName);
    CleanUIConfig_AddControl(self, CUIConfig_LoadName);
    CleanUIConfig_AddControl(self, CUIConfig_Reset);
    
    -- ActionBars
    local actionBars = CreateFrame("Frame", "CUIConfigActionBars");
    actionBars.name = CONFIG_ACTIONBARS_TITLE;
    actionBars.parent = "CleanUI";
    actionBars.addonname = "CleanUI";
    InterfaceOptions_AddCategory(actionBars); 

    CleanUIConfig_CreateHeader(actionBars, CONFIG_ACTIONBARS_TITLE , CONFIG_ACTIONBARS_INFO);
    
    CleanUIConfig_AddCheckButton(actionBars, "CUIConfig_ToggleCleanActionBars",
                CONFIG_TOGGLECLEANACTIONBARS, CleanUIConfig_ToggleCleanActionBars);
    
    CleanUIConfig_AddCheckButton(actionBars, "CUIConfig_ToggleMacroNames",
                CONFIG_TOGGLEMACRONAMES, CleanUIConfig_ToggleMacroNames);
    
    CleanUIConfig_AddCheckButton(actionBars, "CUIConfig_ToggleActionButtonBorder",
                CONFIG_TOGGLEACTIONBUTTONBORDER, CleanUIConfig_ToggleActionButtonBorder);
    
    CleanUIConfig_AddCheckButton(actionBars, "CUIConfig_ToggleShapeshiftBarBorder",
                CONFIG_TOGGLESHAPESHIFTBARBORDER, CleanUIConfig_ToggleShapeshiftBarBorder);
                
    CleanUIConfig_AddCheckButton(actionBars, "CUIConfig_TogglePetActionBarBorder",
                CONFIG_TOGGLEPETACTIONBARBORDER, CleanUIConfig_TogglePetActionBarBorder);
                
    CleanUIConfig_AddCheckButton(actionBars, "CUIConfig_ToggleMasqueForActionButtons",
                CONFIG_TOGGLEMASQUEFORACTIONBUTTONS, CleanUIConfig_ToggleMasqueForActionButtons);
                
    CleanUIConfig_AddCheckButton(actionBars, "CUIConfig_ToggleRangeIndicatorForActionButtons",
                CONFIG_SHOW_RANGEINDICATOR, CleanUIConfig_ToggleRangeIndicatorForActionButtons);
    
    -- DeBuffs
    local debuffs = CreateFrame("Frame", "CUIConfigDeBuffs");
    debuffs.name = CONFIG_DEBUFFS_TITLE;
    debuffs.parent = "CleanUI";
    debuffs.addonname = "CleanUI";
    InterfaceOptions_AddCategory(debuffs);

    CleanUIConfig_CreateHeader(debuffs, CONFIG_DEBUFFS_TITLE , CONFIG_DEBUFFS_INFO);

    CleanUIConfig_AddCheckButton(debuffs, "CUIConfig_ToggleDeBuffsForActionButtons",
                CONFIG_TOGGLEDEBUFFSFORACTIONBUTTONS, CleanUIConfig_ToggleDeBuffsForActionButtons);
                
    CleanUIConfig_AddControl(debuffs, CleanUIDeBuffsBarColorExample);
                
    CleanUIConfig_AddSlider(debuffs, "CUIConfig_DeBuffsBarHeight",
                CONFIG_TOGGLEDEBUFFSFORACTIONBUTTONS_HEIGHT, 1, 8, 1, CleanUIConfig_SelectDeBuffsBarHeight);
    
    CleanUIConfig_AddCheckButton(debuffs, "CUIConfig_ToggleMasqueForBuffs",
                CONFIG_TOGGLEMASQUEFORBUFFS, CleanUIConfig_ToggleMasqueForBuffs);
    
    CleanUIConfig_AddCheckButton(debuffs, "CUIConfig_ToggleBiggerDebuffs",
                CONFIG_TOGGLEBIGGERDEBUFFS, CleanUIConfig_ToggleBiggerDebuffs);
    
    -- CastingBars
    local castingbars = CreateFrame("Frame", "CUIConfigCastingBars");
    castingbars.name = CONFIG_CASTINGBARS_TITLE;
    castingbars.parent = "CleanUI";
    castingbars.addonname = "CleanUI";
    InterfaceOptions_AddCategory(castingbars);

    CleanUIConfig_CreateHeader(castingbars, CONFIG_CASTINGBARS_TITLE , CONFIG_CASTINGBARS_INFO);
    
    CleanUIConfig_AddCheckButton(castingbars, "CUIConfig_ToggleChangeCastingBars",
                CONFIG_TOGGLECHANGECASTINGBARS, CleanUIConfig_ToggleChangeCastingBars);
    
    CleanUIConfig_AddCheckButton(castingbars, "CUIConfig_ToggleCastingBarsShowPetBar",
                CONFIG_TOGGLECASTINGBARS_PETBAR, CleanUIConfig_ToggleCastingBarsShowPetBar);
                
    CleanUIConfig_AddSlider(castingbars, "CUIConfig_SelectCastingBarAlpha",
                CONFIG_TOGGLECASTINGBARALPHA, 0, 1, 0.01, CleanUIConfig_SelectCastingBarAlpha);
                
    CleanUIConfig_AddSlider(castingbars, "CUIConfig_SelectCastingBarWidth",
                CONFIG_TOGGLECASTINGBARWIDTH, 100, 500, 1, CleanUIConfig_SelectCastingBarWidth);
                
    CleanUIConfig_AddSlider(castingbars, "CUIConfig_SelectPlayerCastingBarHeight",
                CONFIG_TOGGLEPLAYERCASTINGBARHEIGHT, 12, 64, 1, CleanUIConfig_SelectPlayerCastingBarHeight);
                
    CleanUIConfig_AddSlider(castingbars, "CUIConfig_SelectPlayerCastingBarImageSize",
                CONFIG_TOGGLEPLAYERCASTINGBARIMAGESIZE, 12, 64, 1, CleanUIConfig_SelectPlayerCastingBarImageSize);
                
    CleanUIConfig_AddSlider(castingbars, "CUIConfig_SelectPetCastingBarHeight",
                CONFIG_TOGGLEPETCASTINGBARHEIGHT, 12, 64, 1, CleanUIConfig_SelectPetCastingBarHeight);
    
    CleanUIConfig_AddCheckButton(castingbars, "CUIConfig_ToggleCastingBarsShowGlobalCooldown",
                CONFIG_TOGGLESHOWGLOBALCOOLDOWN, CleanUIConfig_ToggleCastingBarsShowGlobalCooldown);
                
    CleanUIConfig_AddSlider(castingbars, "CUIConfig_SelectGlobalCooldownHeight",
                CONFIG_TOGGLEGLOBALCOOLDOWNHEIGHT, 1, 10, 1, CleanUIConfig_SelectGlobalCooldownHeight, 45);
    
    CleanUIConfig_AddCheckButton(castingbars, "CUIConfig_ToggleCastingBarsShowLatency",
                CONFIG_TOGGLESHOWLATENCY, CleanUIConfig_ToggleCastingBarsShowLatency);
    
    -- Minimap
    local minimap = CreateFrame("Frame", "CUIConfigMinimap");
    minimap.name = CONFIG_MINIMAP_TITLE;
    minimap.parent = "CleanUI";
    minimap.addonname = "CleanUI";
    InterfaceOptions_AddCategory(minimap);

    CleanUIConfig_CreateHeader(minimap, CONFIG_MINIMAP_TITLE , CONFIG_MINIMAP_INFO);
    
    CleanUIConfig_AddCheckButton(minimap, "CUIConfig_ToggleCleanMinimap",
                CONFIG_TOGGLECLEANMINIMAP, CleanUIConfig_ToggleCleanMinimap);
                
    CleanUIConfig_AddSlider(minimap, "CUIConfig_SelectMinimapAlpha",
                CONFIG_TOGGLEMINIMAPALPHA, 0, 1, 0.01, CleanUIConfig_SelectMinimapAlpha);
    
    CleanUIConfig_AddCheckButton(minimap, "CUIConfig_ToggleMinimapButtonBar",
                CONFIG_TOGGLEMINIMAPBUTTONBAR, CleanUIConfig_ToggleMinimapButtonBar);
    
    CleanUIConfig_AddCheckButton(minimap, "CUIConfig_ToggleMapLevel",
                CONFIG_TOGGLEMAPLEVEL, CleanUIConfig_ToggleMapLevel);
    
    CleanUIConfig_AddCheckButton(minimap, "CUIConfig_ToggleWayPoints",
                CONFIG_TOGGLEWAYPOINTS, CleanUIConfig_ToggleWayPoints);
                
    CleanUIConfig_AddControl(minimap, CUILocationTextColor);
    
    -- UnitFrames
    local unitframes = CreateFrame("Frame", "CUIConfigUnitFrames");
    unitframes.name = CONFIG_UNITFRAMES_TITLE;
    unitframes.parent = "CleanUI";
    unitframes.addonname = "CleanUI";
    InterfaceOptions_AddCategory(unitframes);

    CleanUIConfig_CreateHeader(unitframes, CONFIG_UNITFRAMES_TITLE , CONFIG_UNITFRAMES_INFO);
    
    CleanUIConfig_AddCheckButton(unitframes, "CUIConfig_ToggleCleanUnitFrames",
                CONFIG_TOGGLECLEANUNITFRAMES, CleanUIConfig_ToggleCleanUnitFrames);
    
    CleanUIConfig_AddCheckButton(unitframes, "CUIConfig_ToggleCleanBossFrames",
                CONFIG_TOGGLECLEANBOSSFRAMES, CleanUIConfig_ToggleCleanBossFrames);
  
    CleanUIConfig_AddDropDown(unitframes, "CUIConfig_PortraitStyleDropDown",
                CONFIG_PORTRAITSTYLE, CUIConfig_PortraitStyleDropDown_Initialize, 200);
    
    CleanUIConfig_AddDropDown(unitframes, "CUIConfig_MonkChiTextureDropDown",
                CONFIG_MONK_CHI, CUIConfig_MonkChiTextureDropDown_Initialize, 200);
    CUIConfig_MonkChiTextureDropDown:CreateTexture("CUIConfig_MonkChiTextureDemo", "ARTWORK");
    CUIConfig_MonkChiTextureDemo:SetSize(30, 30);
    CUIConfig_MonkChiTextureDemo:ClearAllPoints();
    CUIConfig_MonkChiTextureDemo:SetPoint("LEFT", CUIConfig_MonkChiTextureDropDown, "RIGHT", 115, 3);
    CUIConfig_MonkChiTextureDemo:SetTexture("Interface\\AddOns\\CleanUI\\skins\\monk\\"..CleanUIData.MONK_CHI_TEXTURE);
                
    -- RaidFrames
    local raidframes = CreateFrame("Frame", "CUIConfigRaidFrames");
    raidframes.name = CONFIG_RAID_TITLE;
    raidframes.parent = "CleanUI";
    raidframes.addonname = "CleanUI";
    InterfaceOptions_AddCategory(raidframes);
    
    CleanUIConfig_CreateHeader(raidframes, CONFIG_RAID_TITLE , CONFIG_RAID_INFO);
    
    CleanUIConfig_AddCheckButton(raidframes, "CUIConfig_ToggleChangeRaid",
                CONFIG_TOGGLECHANGERAID, CleanUIConfig_ToggleChangeRaid);
    
    -- XpBars
    local xpbars = CreateFrame("Frame", "CUIConfigXpBars");
    xpbars.name = CONFIG_XPBARS_TITLE;
    xpbars.parent = "CleanUI";
    xpbars.addonname = "CleanUI";
    InterfaceOptions_AddCategory(xpbars);
    
    CleanUIConfig_CreateHeader(xpbars, CONFIG_XPBARS_TITLE , CONFIG_XPBARS_INFO);
    
    CleanUIConfig_AddCheckButton(xpbars, "CUIConfig_ToggleXpFrame",
                CONFIG_TOGGLEXPFRAME, CleanUIConfig_ToggleXpFrame);
    
    CleanUIConfig_AddCheckButton(xpbars, "CUIConfig_ToggleOrigXpBar",
                CONFIG_TOGGLE_ORIG_XPBAR, CleanUIConfig_ToggleOrigXpBar);
                
    CleanUIConfig_AddSlider(xpbars, "CUIConfig_SelectXpFrameWidth",
                CONFIG_TOGGLEXPFRAMEWIDTH, 100, 1000, 1, CleanUIConfig_SelectXpFrameWidth):SetWidth(300);
                
    CleanUIConfig_AddSlider(xpbars, "CUIConfig_SelectXpBarHeight",
                CONFIG_TOGGLEXPBARHEIGHT, 12, 45, 1, CleanUIConfig_SelectXpBarHeight):SetWidth(300);
    
    CleanUIConfig_AddCheckButton(xpbars, "CUIConfig_ToggleXpFrame_X_Xmax",
                CONFIG_TOGGLEXPFRAME_X_XMAX, CleanUIConfig_ToggleXpFrame_X_Xmax);
    
    CleanUIConfig_AddCheckButton(xpbars, "CUIConfig_ToggleXpFrame_Percent",
                CONFIG_TOGGLEXPFRAME_PERCENT, CleanUIConfig_ToggleXpFrame_Percent);
    
    CleanUIConfig_AddCheckButton(xpbars, "CUIConfig_ToggleXpFrame_MaxLevel",
                CONFIG_TOGGLEXPFRAME_MAXLEVEL, CleanUIConfig_ToggleXpFrame_MaxLevel);
    
    CleanUIConfig_AddCheckButton(xpbars, "CUIConfig_ToggleXpFrame_Unknown",
                CONFIG_TOGGLEXPFRAME_UNKNOWN, CleanUIConfig_ToggleXpFrame_Unknown);
    
    -- Bags
    local bags = CreateFrame("Frame", "CUIConfigBags");
    bags.name = CONFIG_BAGS_TITLE;
    bags.parent = "CleanUI";
    bags.addonname = "CleanUI";
    InterfaceOptions_AddCategory(bags);
    
    CleanUIConfig_CreateHeader(bags, CONFIG_BAGS_TITLE , CONFIG_BAGS_INFO);
    
    CleanUIConfig_AddCheckButton(bags, "CUIConfig_ToggleChangeBags",
                CONFIG_TOGGLECHANGEBAGS, CleanUIConfig_ToggleChangeBags);
    
    CleanUIConfig_AddCheckButton(bags, "CUIConfig_ToggleColorizeItems",
                CONFIG_TOGGLECOLORIZEBAGITEMS, CleanUIConfig_ToggleColorizeItems);
    
    CleanUIConfig_AddCheckButton(bags, "CUIConfig_ToggleShowWhiteAsGray",
                CONFIG_TOGGLESHOWWHITEASGRAY, CleanUIConfig_ToggleShowWhiteAsGray, 20, 45);
    
    CleanUIConfig_AddCheckButton(bags, "CUIConfig_ToggleBagsAutoRepair",
                CONFIG_TOGGLEAUTOREPAIR, CleanUIConfig_ToggleBagsAutoRepair);
    
    CleanUIConfig_AddCheckButton(bags, "CUIConfig_ToggleBagsAutoSellGray",
                CONFIG_TOGGLEAUTOSELLGRAY, CleanUIConfig_ToggleBagsAutoSellGray);
    
    -- Chat
    local chat = CreateFrame("Frame", "CUIConfigChat");
    chat.name = CONFIG_CHAT_TITLE;
    chat.parent = "CleanUI";
    chat.addonname = "CleanUI";
    InterfaceOptions_AddCategory(chat);
    
    CleanUIConfig_CreateHeader(chat, CONFIG_CHAT_TITLE , CONFIG_CHAT_INFO);
    
    CleanUIConfig_AddCheckButton(chat, "CUIConfig_ToggleChangeChat",
                CONFIG_TOGGLECHANGECHAT, CleanUIConfig_ToggleChangeChat);
    
    CleanUIConfig_AddCheckButton(chat, "CUIConfig_ToggleDisableAltArrowKeyMode",
                CONFIG_TOGGLEDISABLE_ALTARROWKEYMODE, CleanUIConfig_ToggleDisableAltArrowKeyMode);
    
    CleanUIConfig_AddCheckButton(chat, "CUIConfig_ToggleShowChatActionBar",
                CONFIG_TOGGLESHOWCHATACTIONBAR, CleanUIConfig_ToggleShowChatActionBar);
    
    CleanUIConfig_AddCheckButton(chat, "CUIConfig_ToggleShowChatEmoticons",
                CONFIG_TOGGLESHOWCHATEMOTICONS, CleanUIConfig_ToggleShowChatEmoticons);
                
    CleanUIConfig_AddSlider(chat, "CUIConfig_SelectChatFontSize",
                FONT_SIZE, 7, 36, 1, CleanUIConfig_SelectChatFontSize);
                
    
    -- Tooltips
    local tooltips = CreateFrame("Frame", "CUIConfigTooltips");
    tooltips.name = CONFIG_TOOLTIP_TITLE;
    tooltips.parent = "CleanUI";
    tooltips.addonname = "CleanUI";
    InterfaceOptions_AddCategory(tooltips);
    
    CleanUIConfig_CreateHeader(tooltips, CONFIG_TOOLTIP_TITLE , CONFIG_TOOLTIP_INFO);
    
    CleanUIConfig_AddCheckButton(tooltips, "CUIConfig_ToggleTooltipsBackdrop",
                CONFIG_TOOLTIP_BACKDROP, CleanUIConfig_ToggleTooltipsBackdrop);
    
    CleanUIConfig_AddCheckButton(tooltips, "CUIConfig_ToggleHideTooltipsInCombat",
                CONFIG_TOOLTIP_HIDE_IN_COMBAT, CleanUIConfig_ToggleHideTooltipsInCombat);

    CleanUIConfig_AddDropDown(tooltips, "CUIConfig_TooltipPositionDropDown",
                CONFIG_TOOLTIP_POSITION_LABEL, CUIConfig_TooltipPositionDropDown_Initialize, 175);
    
    -- Nameplates
    local nameplates = CreateFrame("Frame", "CUIConfigNameplates");
    nameplates.name = CONFIG_NAMEPLATES_TITLE;
    nameplates.parent = "CleanUI";
    nameplates.addonname = "CleanUI";
    InterfaceOptions_AddCategory(nameplates);
    
    CleanUIConfig_CreateHeader(nameplates, CONFIG_NAMEPLATES_TITLE , CONFIG_NAMEPLATES_INFO);
    
    CleanUIConfig_AddCheckButton(nameplates, "CUIConfig_ToggleChangeNameplates",
                CONFIG_TOGGLECHANGENAMEPLATES, CleanUIConfig_ToggleChangeNameplates);
    
    CleanUIConfig_AddCheckButton(nameplates, "CUIConfig_ToggleNameplatesPercent",
                CONFIG_TOGGLENAMEPLATES_PERCENT, CleanUIConfig_ToggleNameplatesPercent);
    
    CleanUIConfig_AddCheckButton(nameplates, "CUIConfig_ToggleNameplatesHighlightTarget",
                CONFIG_TOGGLENAMEPLATES_HIGHLIGHTTARGET, CleanUIConfig_ToggleNameplatesHighlightTarget);
    
    CleanUIConfig_AddCheckButton(nameplates, "CUIConfig_ToggleNameplatesComboPoints",
                COMBAT_TEXT_SHOW_COMBO_POINTS_TEXT, CleanUIConfig_ToggleNameplatesComboPoints);
    
    CleanUIConfig_AddCheckButton(nameplates, "CUIConfig_ToggleNameplatesCombatOnly",
                CONFIG_TOGGLENAMEPLATES_COMBATONLY, CleanUIConfig_ToggleNameplatesCombatOnly);
    
    -- DataBroker
    local plugins = CreateFrame("Frame", "CUIConfigDataBroker");
    plugins.name = CONFIG_DATABROKER_TITLE;
    plugins.parent = "CleanUI";
    plugins.addonname = "CleanUI";
    InterfaceOptions_AddCategory(plugins);
    
    CleanUIConfig_CreateHeader(plugins, CONFIG_DATABROKER_TITLE , CONFIG_DATABROKER_INFO);
    
    CleanUIConfig_AddCheckButton(plugins, "CUIConfig_ToggleShowDataBroker",
                CONFIG_TOGGLESHOWDATABROKER, CleanUIConfig_ToggleShowDataBroker);

    CleanUIConfig_AddSlider(plugins, "CUIConfig_SelectDataBrokerCountRows",
                CONFIG_DATABROKER_COUNTROWS, 1, 20, 1, CleanUIConfig_SelectDataBrokerCountRows);
end

function CleanUIConfig_CreateHeader(parent, title, info)    
    local headline, subtext;
    
    headline = parent:CreateFontString(parent:GetName().."Title", "ARTWORK", "CUIOptionsTitleTemplate");
    headline:SetText("|c333399ff"..title.."|r");
    headline:ClearAllPoints(); 
    headline:SetPoint("TOPLEFT", parent, "TOPLEFT", 16, -16);
    
    subtext = parent:CreateFontString(parent:GetName().."SubText", "ARTWORK", "CUIOptionsSubTextTemplate");
    subtext:SetText(info);
    subtext:ClearAllPoints(); 
    subtext:SetPoint("TOPLEFT", parent, "TOPLEFT", 16, -48);
    subtext:SetPoint("BOTTOMRIGHT", parent, "TOPRIGHT", -16, -85);
end

function CleanUIConfig_AddControl(parent, control, xoffset)

    control:SetParent(parent);

    local liste = controls[parent:GetName()];
    if (not liste) then
        liste = {};
        controls[parent:GetName()] = liste;
    end
    
    local size = table.getn(liste);
    
    if (xoffset) then
        control.xoffset = xoffset;
    end
    
    local ref = parent;
    local relative = "TOPLEFT";
    local x = 15 + (xoffset or 0);
    local y = -90;
    
    if (size > 0) then
        ref = liste[size];
        relative = "BOTTOMLEFT";
        x = (xoffset or 0) - (ref.xoffset or 0);
        y = -14;
    end
    
    table.insert(liste, control);
    
    control:ClearAllPoints(); 
    control:SetPoint("TOPLEFT", ref, relative, x, y);
    
    return control;
end

function CleanUIConfig_AddLabel(parent, name, text)
    local info = parent:CreateFontString(name, "ARTWORK");
    info:SetFontObject("GameFontNormal");
    info:SetWidth(450);
    info:SetHeight(50);
    info:SetJustifyH("LEFT");
    info:SetJustifyV("BOTTOM");
    info:SetText("|cffffffff"..text.."|r");   
    
    return CleanUIConfig_AddControl(parent, info, 10);
end

function CleanUIConfig_AddCheckButton(parent, name, text, onClick, size, xoffset)
    local checkButton = CreateFrame("CheckButton", name, parent, "CUIOptionsCheckButtonTemplate");
    checkButton.text:SetText(text);
    
    checkButton:SetScript("OnClick", onClick);
    
    if (size) then
        checkButton:SetSize(size, size);
    end
    
    return CleanUIConfig_AddControl(parent, checkButton, xoffset);
end

function CleanUIConfig_AddSlider(parent, name, text, min, max, step, onValueChanged, xoffset)
    local slider = CreateFrame("Slider", name, parent, "CUIOptionsSliderTemplate");
    
    slider:SetScript("OnValueChanged", onValueChanged);
    
    slider:SetMinMaxValues(min, max);
    slider:SetValueStep(step);
    
    local label = _G[slider:GetName().."Text"];
    label:SetText(text);
    label:ClearAllPoints();
    label:SetPoint("LEFT", slider, "RIGHT", 15, 0);
    label:SetFontObject("GameFontNormal");
                        
    local textLow = _G[slider:GetName().."Low"];
    local textHigh = _G[slider:GetName().."High"];
    textLow:SetText(min);
    textHigh:SetText(max);   
                         
    return CleanUIConfig_AddControl(parent, slider, xoffset);
end

function CleanUIConfig_AddDropDown(parent, name, text, onInitialize, width, xoffset)
    local dropdown = CreateFrame("Frame", name, parent, "CUIDropDownMenuTemplate");
    
    dropdown.label:SetText(text);
    
    UIDropDownMenu_Initialize(dropdown, onInitialize);
    UIDropDownMenu_JustifyText(dropdown, "LEFT");
    
    if (width) then
        UIDropDownMenu_SetWidth(dropdown, width); 
    end
    
    return CleanUIConfig_AddControl(parent, dropdown, xoffset);
end

function CleanUIConfig_SaveNameChanged()   
    CleanUIConfig_CheckSave();    
end

function CleanUIConfig_CheckSave()   
    local name = _G["CUIConfig_SaveName"]:GetText();
    
    if (not name or name == "") then
        _G["CUIConfig_Save"]:Disable();
    else
        _G["CUIConfig_Save"]:Enable();
    end
end

function CleanUIConfig_Save()
    local name = _G["CUIConfig_SaveName"]:GetText();
    if (name and name ~= "") then
        CleanUICommonData[name] = CleanUIData;
        UIDropDownMenu_Initialize(_G["CUIConfig_LoadName"], CleanUIConfig_LoadName_Initialize);
        PlaySound("igInventoryOepn");
    end
end

function CleanUIConfig_LoadName_Initialize()
	    
	for name, data in pairs(CleanUICommonData) do 
	    local info = UIDropDownMenu_CreateInfo();
        info.text = name;
        info.value = data;
        info.func = function()
                CleanUIConfig_LoadName_Select(name);
            end
        UIDropDownMenu_AddButton(info);
	end
end

function CleanUIConfig_LoadName_Select(name)   
	UIDropDownMenu_SetText(_G["CUIConfig_LoadName"], name);
end

function CleanUIConfig_Load()   
    local name = UIDropDownMenu_GetText(_G["CUIConfig_LoadName"]);
    
    if (name) then
        CleanUIData = CleanUICommonData[name];    
        CleanUIConfig_ConfigChanged();
        PlaySound("igInventoryOepn");
    end
end

function CleanUIConfig_VersionUpdate() 

    if (not CleanUIData.VERSION) then
        CleanUIData.VERSION = 0;
    end

    -- lter als Version 4.23
    if (CleanUIData.VERSION < 423) then  
        DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI|r version update.", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIData.VERSION = 502;
end

function CleanUIConfig_Init()
    CleanUIConfig_VersionUpdate();

    CleanUIConfig_CheckSave();
    
    UIDropDownMenu_Initialize(_G["CUIConfig_LoadName"], CleanUIConfig_LoadName_Initialize);

    CleanUIData.SCREENSHOT = CleanUIData.SCREENSHOT or 1;

    CleanUIData.STATUSBAR_STYLE = CleanUIData.STATUSBAR_STYLE or 1;
    CleanUIData.CUI_STATUSBAR = CleanUIData.CUI_STATUSBAR or "Interface\\AddOns\\CleanUI\\skins\\StatusBar";
    CleanUIData.CUI_STATUSBAR_VERTICAL = CleanUIData.CUI_STATUSBAR_VERTICAL or "Interface\\AddOns\\CleanUI\\skins\\StatusBarVertical";
    
    CleanUIData.CHANGE_ACTIONBARS = CleanUIData.CHANGE_ACTIONBARS or 1; 
    CleanUIData.ACTIONBARS_SHOWMACRONAMES = CleanUIData.ACTIONBARS_SHOWMACRONAMES or 0; 
    CleanUIData.ACTIONBARS_STATUSPOSITION = CleanUIData.ACTIONBARS_STATUSPOSITION or 1; 
    CleanUIData.ACTIONBARS_ACTIONBUTTON_BORDER = CleanUIData.ACTIONBARS_ACTIONBUTTON_BORDER or 1;
    CleanUIData.ACTIONBARS_SHAPESHIFTBAR_BORDER = CleanUIData.ACTIONBARS_SHAPESHIFTBAR_BORDER or 1;
    CleanUIData.ACTIONBARS_PETACTIONBAR_BORDER = CleanUIData.ACTIONBARS_PETACTIONBAR_BORDER or 1;    
    
    CleanUIData.MASQUE_ACTIONBUTTONS = CleanUIData.MASQUE_ACTIONBUTTONS or 1;
    CleanUIData.ACTIONBARS_SHOWRANGEINDICATOR = CleanUIData.ACTIONBARS_SHOWRANGEINDICATOR or 0;
    
    CleanUIData.ACTIONBARS_DEBUFFS = CleanUIData.ACTIONBARS_DEBUFFS or 1;
    CleanUIData.ACTIONBARS_DEBUFFS_R = CleanUIData.ACTIONBARS_DEBUFFS_R or 1;
    CleanUIData.ACTIONBARS_DEBUFFS_G = CleanUIData.ACTIONBARS_DEBUFFS_G or 0;
    CleanUIData.ACTIONBARS_DEBUFFS_B = CleanUIData.ACTIONBARS_DEBUFFS_B or 0;
    CleanUIData.ACTIONBARS_DEBUFFS_HEIGHT = CleanUIData.ACTIONBARS_DEBUFFS_HEIGHT or 2; 
    CleanUIData.MASQUE_BUFFS = CleanUIData.MASQUE_BUFFS or 1;
    CleanUIData.BIGGER_DEBUFFS = CleanUIData.BIGGER_DEBUFFS or 1;
    
    CleanUIData.CHANGE_BAGS = CleanUIData.CHANGE_BAGS or 1;
    
    CleanUIData.BAGS_COLORIZE_ITEMS = CleanUIData.BAGS_COLORIZE_ITEMS or 1;
    CleanUIData.BAGS_SHOW_WHITE_AS_GRAY = CleanUIData.BAGS_SHOW_WHITE_AS_GRAY or 1;
    CleanUIData.BAGS_AUTOREPAIR = CleanUIData.BAGS_AUTOREPAIR or 1;
    CleanUIData.BAGS_AUTOSELLGRAY = CleanUIData.BAGS_AUTOSELLGRAY or 1;
    CleanUIData.BAGPACK_MINIMAP_POS = CleanUIData.BAGPACK_MINIMAP_POS or 45;
    
    CleanUIData.CHANGE_CASTINGBARS = CleanUIData.CHANGE_CASTINGBARS or 1; 
    CleanUIData.CASTINGBARS_SHOWPETBAR = CleanUIData.CASTINGBARS_SHOWPETBAR or 1; 
    CleanUIData.CASTINGBARS_ALPHA = CleanUIData.CASTINGBARS_ALPHA or 1; 
    CleanUIData.CASTINGBARS_WIDTH = CleanUIData.CASTINGBARS_WIDTH or 300; 
    CleanUIData.CASTINGBARS_PLAYERHEIGHT = CleanUIData.CASTINGBARS_PLAYERHEIGHT or 24; 
    CleanUIData.CASTINGBARS_IMAGESIZE = CleanUIData.CASTINGBARS_IMAGESIZE or 24; 
    CleanUIData.CASTINGBARS_PETHEIGHT = CleanUIData.CASTINGBARS_PETHEIGHT or 16;  
    CleanUIData.CASTINGBARS_GLOBALCOOLDOWN = CleanUIData.CASTINGBARS_GLOBALCOOLDOWN or 1;  
    CleanUIData.CASTINGBARS_GLOBALCOOLDOWN_HEIGHT = CleanUIData.CASTINGBARS_GLOBALCOOLDOWN_HEIGHT or 2;  
    CleanUIData.CASTINGBARS_LATENCY = CleanUIData.CASTINGBARS_LATENCY or 1;  
    
    CleanUIData.CHANGE_MINIMAP = CleanUIData.CHANGE_MINIMAP or 1; 
    CleanUIData.MINIMAP_ALPHA = CleanUIData.MINIMAP_ALPHA or 1; 
    CleanUIData.WATCHFRAME_ALPHA = CleanUIData.WATCHFRAME_ALPHA or 0.75; 
    CleanUIData.MINIMAP_SHOWBUTTONBAR = CleanUIData.MINIMAP_SHOWBUTTONBAR or 1;  
    CleanUIData.MINIMAP_RIGHTBUTTONS = CleanUIData.MINIMAP_RIGHTBUTTONS or {};  
    CleanUIData.MAP_SHOWQUESTLEVEL = CleanUIData.MAP_SHOWQUESTLEVEL or 1;
    CleanUIData.MAP_SHOWSHIPROUTES = CleanUIData.MAP_SHOWSHIPROUTES or 1;
    CleanUIData.MAP_SHOWWAYPOINTS = CleanUIData.MAP_SHOWWAYPOINTS or 1;
    CleanUIData.TLOC_R = CleanUIData.TLOC_R or 1;
    CleanUIData.TLOC_G = CleanUIData.TLOC_G or 1;
    CleanUIData.TLOC_B = CleanUIData.TLOC_B or 1;
    
    CleanUIData.CHANGE_UNITFRAMES = CleanUIData.CHANGE_UNITFRAMES or 1;  
    CleanUIData.CHANGE_BOSSFRAMES = CleanUIData.CHANGE_BOSSFRAMES or 1;   
    CleanUIData.PORTRAIT_STYLE = CleanUIData.PORTRAIT_STYLE or 1;      
    CleanUIData.UNITFRAME_CUSTOM_POSITIONS = CleanUIData.UNITFRAME_CUSTOM_POSITIONS or {};
    CleanUIData.MONK_CHI_TEXTURE_INDEX = CleanUIData.MONK_CHI_TEXTURE_INDEX or 14;    
    CleanUIData.MONK_CHI_TEXTURE = CleanUIData.MONK_CHI_TEXTURE or "chi_white";    
    
    CleanUIData.SHOW_XPFRAME = CleanUIData.SHOW_XPFRAME or 0;
    CleanUIData.SHOW_ORIG_XPBAR = CleanUIData.SHOW_ORIG_XPBAR or 1;
    CleanUIData.XPFRAME_WIDTH = CleanUIData.XPFRAME_WIDTH or 210;    
    CleanUIData.XPBAR_HEIGHT = CleanUIData.XPBAR_HEIGHT or 13;    
    CleanUIData.XPFRAME_X_XMAX = CleanUIData.XPFRAME_X_XMAX or 1;
    CleanUIData.XPFRAME_PERCENT = CleanUIData.XPFRAME_PERCENT or 1;
    CleanUIData.XPFRAME_MAXLEVEL = CleanUIData.XPFRAME_MAXLEVEL or 0;
    CleanUIData.XPFRAME_UNKNOWN = CleanUIData.XPFRAME_UNKNOWN or 0;
    
    CleanUIData.CHANGE_CHAT = CleanUIData.CHANGE_CHAT or 1;
    CleanUIData.DISABLE_ALTARROWKEYMODE = CleanUIData.DISABLE_ALTARROWKEYMODE or 1;
    CleanUIData.SHOW_CHAT_ACTIONBAR = CleanUIData.SHOW_CHAT_ACTIONBAR or 1;
    CleanUIData.SHOW_CHAT_EMOTICONS = CleanUIData.SHOW_CHAT_EMOTICONS or 1;
    CleanUIData.CHAT_FONT_SIZE = CleanUIData.CHAT_FONT_SIZE or 14;
    
    CleanUIData.CHANGE_RAID = CleanUIData.CHANGE_RAID or 1;
    
    CleanUIData.TOOLTIPS_HIDEINCOMBAT = CleanUIData.TOOLTIPS_HIDEINCOMBAT or 0;
    CleanUIData.TOOLTIPS_BACKDROP = CleanUIData.TOOLTIPS_BACKDROP or 1;
    CleanUIData.TOOLTIPS_POSITION = CleanUIData.TOOLTIPS_POSITION or 1;
    
    CleanUIData.CHANGE_NAMEPLATES = CleanUIData.CHANGE_NAMEPLATES or 1;
    CleanUIData.NAMEPLATES_PERCENT = CleanUIData.NAMEPLATES_PERCENT or 1;
    CleanUIData.NAMEPLATES_HIGHLIGHTTARGET = CleanUIData.NAMEPLATES_HIGHLIGHTTARGET or 1;
    CleanUIData.NAMEPLATES_SHOWCOMBOPOINTS = CleanUIData.NAMEPLATES_SHOWCOMBOPOINTS or 1;
    CleanUIData.NAMEPLATES_COMBATONLY = CleanUIData.NAMEPLATES_COMBATONLY or 0;
    
    CleanUIData.SHOW_DATABROKER = CleanUIData.SHOW_DATABROKER or 1;
    CleanUIData.DATABROKER_COUNTROWS = CleanUIData.DATABROKER_COUNTROWS or 2;

    CleanUIData.DataBroker_Disabled = CleanUIData.DataBroker_Disabled or {};
    
    CleanUIConfig_InitDataBroker();
end

function CleanUIConfig_InitDataBroker()
    
    local count = 0;    
    local row = 0;  
    local column = 0;
    
    local x_offset = 40;
    local y_offset = 40;
    
    local x, y;

    for name, button in pairs(db_buttons) do 
        
        local dataobj = button.dataobj;
        
        local name = "CUIConfig_DataBroker_ToggleButton"..count;
        
        local checkbutton = _G[name];
        if (not checkbutton) then
            checkbutton = CreateFrame("CheckButton", name, CUIConfigDataBroker, "OptionsCheckButtonTemplate");
            checkbutton:SetWidth(32);
            checkbutton:SetHeight(32);
            checkbutton:SetHitRectInsets(0, 0, 0, 0);
            checkbutton:HookScript("OnEnter", CleanUIConfig_DataBroker_OnEnter);
            checkbutton:HookScript("OnLeave", CleanUIConfig_DataBroker_OnLeave);
            checkbutton:HookScript("OnClick", CleanUIConfig_DataBroker_OnClick);
        end
        
        checkbutton:SetParent(CUIConfigDataBroker);
	
        checkbutton:SetNormalTexture(dataobj.icon);
        checkbutton:SetPushedTexture(dataobj.icon);
        checkbutton:SetHighlightTexture(nil);
        checkbutton.dataobj = dataobj;
        
        column = mod(count, 10);            
        if (column == 0) then
            row = row + 1;
        end
            
        x = column * x_offset;
        y = row * y_offset + 30;
        
        checkbutton:ClearAllPoints();
        checkbutton:SetPoint("TOPLEFT", CUIConfig_SelectDataBrokerCountRows, "TOPLEFT", x, -y);
        
        local checked = CleanUIData.DataBroker_Disabled[dataobj.cui_name] ~= 1;
        checkbutton:SetChecked(checked);
        
        count = count + 1;
    end
end

function CleanUIConfig_DataBroker_OnClick(self) 
    local dataobj = self.dataobj;
    local name = dataobj.cui_name;
    
    if (self:GetChecked()) then
        CleanUIData.DataBroker_Disabled[name] = 0;
    else
        CleanUIData.DataBroker_Disabled[name] = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_DataBroker_OnEnter(self)
    local dataobj = self.dataobj;
	GameTooltip:SetOwner(self, "ANCHOR_BOTTOM");
    GameTooltip:SetText(dataobj.cui_name);
    GameTooltip:Show();
end

function CleanUIConfig_DataBroker_OnLeave()
	GameTooltip:FadeOut();
end

function CleanUIConfig_Reset() 
    CleanUIConfig_LoadDefaultUnitFramePositions();
    
    CleanUIData.SCREENSHOT = 1;

    CleanUIData.STATUSBAR_STYLE = 1;
    CleanUIData.CUI_STATUSBAR = "Interface\\AddOns\\CleanUI\\skins\\StatusBar";
    CleanUIData.CUI_STATUSBAR_VERTICAL = "Interface\\AddOns\\CleanUI\\skins\\StatusBarVertical";
    
    CleanUIData.CHANGE_ACTIONBARS = 1;
    CleanUIData.ACTIONBARS_SHOWMACRONAMES = 0;
    CleanUIData.ACTIONBARS_ACTIONBUTTON_BORDER = 1;
    CleanUIData.ACTIONBARS_SHAPESHIFTBAR_BORDER = 1;
    CleanUIData.ACTIONBARS_PETACTIONBAR_BORDER = 1;
    CleanUIData.MASQUE_ACTIONBUTTONS = 1;
    CleanUIData.ACTIONBARS_SHOWRANGEINDICATOR = 0;
    
    CleanUIData.ACTIONBARS_DEBUFFS = 1;
    CleanUIData.ACTIONBARS_DEBUFFS_R = 1;
    CleanUIData.ACTIONBARS_DEBUFFS_G = 0;
    CleanUIData.ACTIONBARS_DEBUFFS_B = 0;
    CleanUIData.ACTIONBARS_DEBUFFS_HEIGHT = 2;
    CleanUIData.MASQUE_BUFFS = 1;
    CleanUIData.BIGGER_DEBUFFS = 1;
    
    CleanUIData.CHANGE_BAGS = 1;
    CleanUIData.BAGS_COLORIZE_ITEMS = 1;
    CleanUIData.BAGS_SHOW_WHITE_AS_GRAY = 1;
    CleanUIData.BAGS_AUTOREPAIR = 1;
    CleanUIData.BAGS_AUTOSELLGRAY = 1;
    CleanUIData.BAGPACK_MINIMAP_POS = 45;
    
    CleanUIData.CHANGE_CASTINGBARS = 1;
    CleanUIData.CASTINGBARS_SHOWPETBAR = 1;
    CleanUIData.CASTINGBARS_ALPHA = 1;
    CleanUIData.CASTINGBARS_WIDTH = 300;
    CleanUIData.CASTINGBARS_PLAYERHEIGHT = 24;
    CleanUIData.CASTINGBARS_IMAGESIZE = 24;
    CleanUIData.CASTINGBARS_PETHEIGHT = 16;
    CleanUIData.CASTINGBARS_GLOBALCOOLDOWN = 1;
    CleanUIData.CASTINGBARS_GLOBALCOOLDOWN_HEIGHT = 2;
    CleanUIData.CASTINGBARS_LATENCY = 1;
    
    CleanUIData.CHANGE_MINIMAP = 1;
    CleanUIData.MINIMAP_ALPHA = 1;
    CleanUIData.WATCHFRAME_ALPHA = 0.75;
    CleanUIData.MINIMAP_SHOWBUTTONBAR = 1;
    CleanUIData.MINIMAP_RIGHTBUTTONS = {};
    CleanUIData.MAP_SHOWQUESTLEVEL = 1;
    CleanUIData.MAP_SHOWSHIPROUTES = 1;
    CleanUIData.MAP_SHOWWAYPOINTS = 1;
    CleanUIData.TLOC_R = 1;
    CleanUIData.TLOC_G = 1;
    CleanUIData.TLOC_B = 1;
    
    CleanUIData.CHANGE_UNITFRAMES = 1;
    CleanUIData.CHANGE_BOSSFRAMES = 1;
    CleanUIData.PORTRAIT_STYLE = 1;
    CleanUIData.UNITFRAME_CUSTOM_POSITIONS = {};
    CleanUIData.MONK_CHI_TEXTURE_INDEX = 14;
    CleanUIData.MONK_CHI_TEXTURE = "chi_white";
    
    CleanUIData.SHOW_XPFRAME = 0;
    CleanUIData.SHOW_ORIG_XPBAR = 1;
    CleanUIData.XPFRAME_WIDTH = 210;
    CleanUIData.XPBAR_HEIGHT = 13;
    CleanUIData.XPFRAME_X_XMAX = 1;
    CleanUIData.XPFRAME_PERCENT = 1;
    CleanUIData.XPFRAME_MAXLEVEL = 0;
    CleanUIData.XPFRAME_UNKNOWN = 0;

    CleanUIData.CHANGE_CHAT = 1;
    CleanUIData.DISABLE_ALTARROWKEYMODE = 1;
    CleanUIData.SHOW_CHAT_ACTIONBAR = 1;
    CleanUIData.SHOW_CHAT_EMOTICONS = 1;
    CleanUIData.CHAT_FONT_SIZE = 14;
    
    CleanUIData.CHANGE_RAID = 1;
    
    CleanUIData.TOOLTIPS_HIDEINCOMBAT = 0;
    CleanUIData.TOOLTIPS_BACKDROP = 1;
    CleanUIData.TOOLTIPS_POSITION = 1;
    
    CleanUIData.CHANGE_NAMEPLATES = 1;
    CleanUIData.NAMEPLATES_PERCENT = 1;
    CleanUIData.NAMEPLATES_HIGHLIGHTTARGET = 1;
    CleanUIData.NAMEPLATES_SHOWCOMBOPOINTS = 1;
    CleanUIData.NAMEPLATES_COMBATONLY = 0;
    
    CleanUIData.SHOW_DATABROKER = 1;
    CleanUIData.DATABROKER_COUNTROWS = 2;
    
    CleanUIData.DataBroker_Disabled = {};

    -- initialize
    CleanUIConfig_Init();        
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ConfigChanged()
    InterfaceOptionsFrame.gameRestart = true;
    CleanUIConfig_ReloadConfig();
end

function CleanUIConfig_ReloadConfig() 

    if (not cui_config_loaded) then
        return;
    end
    
    CleanUIConfig_Init();
    
    _G["CUIConfig_ToggleScreenshot"]:SetChecked(CleanUIData.SCREENSHOT);
    
    UIDropDownMenu_SetSelectedValue(_G["CUIConfig_StatusBarStyleDropDown"], CleanUIData.STATUSBAR_STYLE);
	UIDropDownMenu_SetText(_G["CUIConfig_StatusBarStyleDropDown"], STATUSBAR_STYLE[CleanUIData.STATUSBAR_STYLE]);
    
    _G["CUIConfig_ToggleCleanActionBars"]:SetChecked(CleanUIData.CHANGE_ACTIONBARS);
    _G["CUIConfig_ToggleMacroNames"]:SetChecked(CleanUIData.ACTIONBARS_SHOWMACRONAMES);
    _G["CUIConfig_ToggleActionButtonBorder"]:SetChecked(CleanUIData.ACTIONBARS_ACTIONBUTTON_BORDER);
    _G["CUIConfig_ToggleShapeshiftBarBorder"]:SetChecked(CleanUIData.ACTIONBARS_SHAPESHIFTBAR_BORDER);
    _G["CUIConfig_TogglePetActionBarBorder"]:SetChecked(CleanUIData.ACTIONBARS_PETACTIONBAR_BORDER);
    _G["CUIConfig_ToggleMasqueForActionButtons"]:SetChecked(CleanUIData.MASQUE_ACTIONBUTTONS);
    _G["CUIConfig_ToggleRangeIndicatorForActionButtons"]:SetChecked(CleanUIData.ACTIONBARS_SHOWRANGEINDICATOR);

    _G["CUIConfig_ToggleDeBuffsForActionButtons"]:SetChecked(CleanUIData.ACTIONBARS_DEBUFFS);
    _G["CleanUIDeBuffsBarColorExample"]:SetStatusBarColor(CleanUIData.ACTIONBARS_DEBUFFS_R, CleanUIData.ACTIONBARS_DEBUFFS_G, CleanUIData.ACTIONBARS_DEBUFFS_B);
    _G["CUIConfig_DeBuffsBarHeight"]:SetValue(CleanUIData.ACTIONBARS_DEBUFFS_HEIGHT);
    _G["CUIConfig_DeBuffsBarHeightValue"]:SetText(format("%.0f", CleanUIData.ACTIONBARS_DEBUFFS_HEIGHT));
    _G["CUIConfig_ToggleMasqueForBuffs"]:SetChecked(CleanUIData.MASQUE_BUFFS);
    _G["CUIConfig_ToggleBiggerDebuffs"]:SetChecked(CleanUIData.BIGGER_DEBUFFS);
    
    _G["CUIConfig_ToggleChangeBags"]:SetChecked(CleanUIData.CHANGE_BAGS);
    _G["CUIConfig_ToggleColorizeItems"]:SetChecked(CleanUIData.BAGS_COLORIZE_ITEMS);
    _G["CUIConfig_ToggleShowWhiteAsGray"]:SetChecked(CleanUIData.BAGS_SHOW_WHITE_AS_GRAY);
    _G["CUIConfig_ToggleBagsAutoRepair"]:SetChecked(CleanUIData.BAGS_AUTOREPAIR);
    _G["CUIConfig_ToggleBagsAutoSellGray"]:SetChecked(CleanUIData.BAGS_AUTOSELLGRAY);
    
    _G["CUIConfig_ToggleChangeCastingBars"]:SetChecked(CleanUIData.CHANGE_CASTINGBARS);
    _G["CUIConfig_ToggleCastingBarsShowPetBar"]:SetChecked(CleanUIData.CASTINGBARS_SHOWPETBAR);
    _G["CUIConfig_SelectCastingBarAlpha"]:SetValue(CleanUIData.CASTINGBARS_ALPHA);
    _G["CUIConfig_SelectCastingBarAlphaValue"]:SetText(format("%.2f", CleanUIData.CASTINGBARS_ALPHA));
    _G["CUIConfig_SelectCastingBarWidth"]:SetValue(CleanUIData.CASTINGBARS_WIDTH);
    _G["CUIConfig_SelectCastingBarWidthValue"]:SetText(format("%.0f", CleanUIData.CASTINGBARS_WIDTH));
    _G["CUIConfig_SelectPlayerCastingBarHeight"]:SetValue(CleanUIData.CASTINGBARS_PLAYERHEIGHT);
    _G["CUIConfig_SelectPlayerCastingBarHeightValue"]:SetText(format("%.0f", CleanUIData.CASTINGBARS_PLAYERHEIGHT));
    _G["CUIConfig_SelectPlayerCastingBarImageSize"]:SetValue(CleanUIData.CASTINGBARS_IMAGESIZE);
    _G["CUIConfig_SelectPlayerCastingBarImageSizeValue"]:SetText(format("%.0f", CleanUIData.CASTINGBARS_IMAGESIZE));
    _G["CUIConfig_SelectPetCastingBarHeight"]:SetValue(CleanUIData.CASTINGBARS_PETHEIGHT);
    _G["CUIConfig_SelectPetCastingBarHeightValue"]:SetText(format("%.0f", CleanUIData.CASTINGBARS_PETHEIGHT));
    _G["CUIConfig_ToggleCastingBarsShowGlobalCooldown"]:SetChecked(CleanUIData.CASTINGBARS_GLOBALCOOLDOWN);
    _G["CUIConfig_SelectGlobalCooldownHeight"]:SetValue(CleanUIData.CASTINGBARS_GLOBALCOOLDOWN_HEIGHT);
    _G["CUIConfig_SelectGlobalCooldownHeightValue"]:SetText(format("%.0f", CleanUIData.CASTINGBARS_GLOBALCOOLDOWN_HEIGHT));
    _G["CUIConfig_ToggleCastingBarsShowLatency"]:SetChecked(CleanUIData.CASTINGBARS_LATENCY);
    
    _G["CUIConfig_ToggleCleanMinimap"]:SetChecked(CleanUIData.CHANGE_MINIMAP);
    _G["CUIConfig_SelectMinimapAlpha"]:SetValue(CleanUIData.MINIMAP_ALPHA);
    _G["CUIConfig_SelectMinimapAlphaValue"]:SetText(format("%.2f", CleanUIData.MINIMAP_ALPHA));
    _G["CUIConfig_SelectWatchFrameAlpha"]:SetValue(CleanUIData.WATCHFRAME_ALPHA);
    _G["CUIConfig_SelectWatchFrameAlphaValue"]:SetText(format("%.2f", CleanUIData.WATCHFRAME_ALPHA));
    _G["CUIConfig_ToggleMinimapButtonBar"]:SetChecked(CleanUIData.MINIMAP_SHOWBUTTONBAR);
    _G["CUIConfig_ToggleMapLevel"]:SetChecked(CleanUIData.MAP_SHOWQUESTLEVEL);
    _G["CUIConfig_ToggleWayPoints"]:SetChecked(CleanUIData.MAP_SHOWWAYPOINTS);
    _G["CUILocationTextColor"]:SetBackdropColor(CleanUIData.TLOC_R, CleanUIData.TLOC_G, CleanUIData.TLOC_B);
      
    _G["CUIConfig_ToggleCleanUnitFrames"]:SetChecked(CleanUIData.CHANGE_UNITFRAMES);
    _G["CUIConfig_ToggleCleanBossFrames"]:SetChecked(CleanUIData.CHANGE_BOSSFRAMES);
    
    UIDropDownMenu_SetSelectedValue(_G["CUIConfig_PortraitStyleDropDown"], CleanUIData.PORTRAIT_STYLE);
    UIDropDownMenu_SetText(_G["CUIConfig_PortraitStyleDropDown"], PORTRAIT_TYPE[CleanUIData.PORTRAIT_STYLE]);
    
    UIDropDownMenu_SetSelectedValue(_G["CUIConfig_MonkChiTextureDropDown"], CleanUIData.MONK_CHI_TEXTURE_INDEX);
    UIDropDownMenu_SetText(_G["CUIConfig_MonkChiTextureDropDown"], MONK_CHI_TEXTURES[CleanUIData.MONK_CHI_TEXTURE_INDEX]);
    
    _G["CUIConfig_ToggleXpFrame"]:SetChecked(CleanUIData.SHOW_XPFRAME);
    _G["CUIConfig_ToggleOrigXpBar"]:SetChecked(CleanUIData.SHOW_ORIG_XPBAR);
    _G["CUIConfig_SelectXpFrameWidth"]:SetValue(CleanUIData.XPFRAME_WIDTH);
    _G["CUIConfig_SelectXpFrameWidthValue"]:SetText(format("%.0f", CleanUIData.XPFRAME_WIDTH));
    _G["CUIConfig_SelectXpBarHeight"]:SetValue(CleanUIData.XPBAR_HEIGHT);
    _G["CUIConfig_SelectXpBarHeightValue"]:SetText(format("%.0f", CleanUIData.XPBAR_HEIGHT));
    _G["CUIConfig_ToggleXpFrame_X_Xmax"]:SetChecked(CleanUIData.XPFRAME_X_XMAX);
    _G["CUIConfig_ToggleXpFrame_Percent"]:SetChecked(CleanUIData.XPFRAME_PERCENT);
    _G["CUIConfig_ToggleXpFrame_MaxLevel"]:SetChecked(CleanUIData.XPFRAME_MAXLEVEL);
    _G["CUIConfig_ToggleXpFrame_Unknown"]:SetChecked(CleanUIData.XPFRAME_UNKNOWN);

    _G["CUIConfig_ToggleChangeChat"]:SetChecked(CleanUIData.CHANGE_CHAT);   
    _G["CUIConfig_ToggleDisableAltArrowKeyMode"]:SetChecked(CleanUIData.DISABLE_ALTARROWKEYMODE); 
    _G["CUIConfig_ToggleShowChatActionBar"]:SetChecked(CleanUIData.SHOW_CHAT_ACTIONBAR);   
    _G["CUIConfig_ToggleShowChatEmoticons"]:SetChecked(CleanUIData.SHOW_CHAT_EMOTICONS);  
    _G["CUIConfig_SelectChatFontSize"]:SetValue(CleanUIData.CHAT_FONT_SIZE);
    _G["CUIConfig_SelectChatFontSizeValue"]:SetText(format("%.0f", CleanUIData.CHAT_FONT_SIZE));
    
    _G["CUIConfig_ToggleChangeRaid"]:SetChecked(CleanUIData.CHANGE_RAID);   
    
    _G["CUIConfig_ToggleChangeNameplates"]:SetChecked(CleanUIData.CHANGE_NAMEPLATES);   
    _G["CUIConfig_ToggleNameplatesPercent"]:SetChecked(CleanUIData.NAMEPLATES_PERCENT);   
    _G["CUIConfig_ToggleNameplatesHighlightTarget"]:SetChecked(CleanUIData.NAMEPLATES_HIGHLIGHTTARGET);  
    _G["CUIConfig_ToggleNameplatesComboPoints"]:SetChecked(CleanUIData.NAMEPLATES_SHOWCOMBOPOINTS);   
    _G["CUIConfig_ToggleNameplatesCombatOnly"]:SetChecked(CleanUIData.NAMEPLATES_COMBATONLY);   
    
    _G["CUIConfig_ToggleShowDataBroker"]:SetChecked(CleanUIData.SHOW_DATABROKER);   
    _G["CUIConfig_SelectDataBrokerCountRows"]:SetValue(CleanUIData.DATABROKER_COUNTROWS);    
    _G["CUIConfig_SelectDataBrokerCountRowsValue"]:SetText(format("%.0f", CleanUIData.DATABROKER_COUNTROWS));
    
    if (CleanUIData.CHANGE_ACTIONBARS == 1) then 
        _G["CUIConfig_ToggleOrigXpBar"]:Enable();
    else
        _G["CUIConfig_ToggleOrigXpBar"]:Disable();
    end
    
    if (CleanUIData.BAGS_COLORIZE_ITEMS == 1) then 
        _G["CUIConfig_ToggleShowWhiteAsGray"]:Enable();
    else
        _G["CUIConfig_ToggleShowWhiteAsGray"]:Disable();
    end
    
    UIDropDownMenu_SetSelectedValue(_G["CUIConfig_TooltipPositionDropDown"], CleanUIData.TOOLTIPS_POSITION);
	UIDropDownMenu_SetText(_G["CUIConfig_TooltipPositionDropDown"], TOOLTIPS_POSITION[CleanUIData.TOOLTIPS_POSITION]);
    _G["CUIConfig_ToggleHideTooltipsInCombat"]:SetChecked(CleanUIData.TOOLTIPS_HIDEINCOMBAT);
    _G["CUIConfig_ToggleTooltipsBackdrop"]:SetChecked(CleanUIData.TOOLTIPS_BACKDROP);
    
    -- update the ui
    CleanUIConfig_InitBorderStyle();
    CleanUIConfig_InitStatusBarStyle();
    
    CleanUIConfig_InitMonkChiTexture();
    
    CleanUI_MoveBagButtons();
    CleanUI_DataBroker_ShowButtons();
    CleanUI_MainMenuBar_UpdateArt();
    CleanUI_StanceBar_UpdateState();
    CleanUI_PetActionBar_Update();
    CleanUI_UpdateMinimap();
    
    CleanUI_UpdateChatFontSize();
    
    CleanUI_UpdateWatchFrameAlpha();
    
    CleanUI_CheckActivateNameplates();
end

function CleanUIConfig_InitBorderStyle()    
    CleanUI_ReplaceAllBorderTextures("UI-Tooltip-Border", UIParent);
    CleanUI_ReplaceAllBorderTextures("frame-border", UIParent); 
end

function CleanUIConfig_InitMonkChiTexture() 
    CleanUIData.MONK_CHI_TEXTURE = "chi_white";
    
    if (CleanUIData.MONK_CHI_TEXTURE_INDEX == 2) then
        CleanUIData.MONK_CHI_TEXTURE = "chi_blue";
    elseif (CleanUIData.MONK_CHI_TEXTURE_INDEX == 3) then
        CleanUIData.MONK_CHI_TEXTURE = "chi_green";
    elseif (CleanUIData.MONK_CHI_TEXTURE_INDEX == 4) then
        CleanUIData.MONK_CHI_TEXTURE = "chi_red";
    elseif (CleanUIData.MONK_CHI_TEXTURE_INDEX == 5) then
        CleanUIData.MONK_CHI_TEXTURE = "chi_yellow";
    elseif (CleanUIData.MONK_CHI_TEXTURE_INDEX == 6) then
        CleanUIData.MONK_CHI_TEXTURE = "chi_turquoise";
    elseif (CleanUIData.MONK_CHI_TEXTURE_INDEX == 7) then
        CleanUIData.MONK_CHI_TEXTURE = "yinyang_gold";
    elseif (CleanUIData.MONK_CHI_TEXTURE_INDEX == 8) then
        CleanUIData.MONK_CHI_TEXTURE = "yinyang_blue";
    elseif (CleanUIData.MONK_CHI_TEXTURE_INDEX == 9) then
        CleanUIData.MONK_CHI_TEXTURE = "yinyang_green";
    elseif (CleanUIData.MONK_CHI_TEXTURE_INDEX == 10) then
        CleanUIData.MONK_CHI_TEXTURE = "yinyang_red";
    elseif (CleanUIData.MONK_CHI_TEXTURE_INDEX == 11) then
        CleanUIData.MONK_CHI_TEXTURE = "yinyang_yellow";
    elseif (CleanUIData.MONK_CHI_TEXTURE_INDEX == 12) then
        CleanUIData.MONK_CHI_TEXTURE = "yinyang_purple";
    elseif (CleanUIData.MONK_CHI_TEXTURE_INDEX == 13) then
        CleanUIData.MONK_CHI_TEXTURE = "yinyang_blue_gold";
    elseif (CleanUIData.MONK_CHI_TEXTURE_INDEX == 14) then
        CleanUIData.MONK_CHI_TEXTURE = "yinyang_blue_white";
    elseif (CleanUIData.MONK_CHI_TEXTURE_INDEX == 15) then
        CleanUIData.MONK_CHI_TEXTURE = "yinyang_blue_purple";
    end
    
    CUIConfig_MonkChiTextureDemo:SetTexture("Interface\\AddOns\\CleanUI\\skins\\monk\\"..CleanUIData.MONK_CHI_TEXTURE);
    
    CleanUI_MonkHarmonyBar_Update();
end

function CleanUIConfig_InitStatusBarStyle() 
    CleanUIData.CUI_STATUSBAR = "Interface\\AddOns\\CleanUI\\skins\\StatusBar";
    CleanUIData.CUI_STATUSBAR_VERTICAL = "Interface\\AddOns\\CleanUI\\skins\\StatusBarVertical";
    
    if (CleanUIData.STATUSBAR_STYLE >= 2) then
        CleanUIData.CUI_STATUSBAR = "Interface\\AddOns\\CleanUI\\skins\\statusbars\\"..STATUSBAR_STYLE[CleanUIData.STATUSBAR_STYLE];
        CleanUIData.CUI_STATUSBAR_VERTICAL = "Interface\\AddOns\\CleanUI\\skins\\statusbars\\"..STATUSBAR_STYLE[CleanUIData.STATUSBAR_STYLE].."Vertical";
    end
    
    CleanUI_InitStatusBarTexture();
end

function CleanUIConfig_LoadDefaultUnitFramePositions() 
    if (InCombatLockdown()) then
        return;
    end
    
    local yoffset = -10 + CleanUI_GetTitanYOffset();
 	
    CleanUI_SaveFramePosition(PlayerFrame, "TOPLEFT", UIParent, "TOPLEFT", 5, yoffset);
    CleanUI_SaveFramePosition(TargetFrame, "TOPLEFT", UIParent, "TOPLEFT", 300, yoffset);
    CleanUI_SaveFramePosition(FocusFrame, "TOPLEFT", UIParent, "TOPLEFT", 595, yoffset);
end

function CleanUIConfig_LoadBattleUnitFramePositions() 
    if (InCombatLockdown()) then
        return;
    end
 	
    CleanUI_SaveFramePosition(PlayerFrame, "TOPLEFT", CleanUIActionButtonsArtFrame, "TOPLEFT", -50, 302);
    CleanUI_SaveFramePosition(TargetFrame, "TOPRIGHT", CleanUIActionButtonsArtFrame, "TOPRIGHT", 50, 302);
    CleanUI_SaveFramePosition(FocusFrame, "TOPLEFT", TargetFrame, "TOPRIGHT", 20, 100);
end

function CleanUIConfig_SaveCustomUnitFramePosition(index)

    local positions = {};
    
    local point, relativeTo, relativePoint, xOfs, yOfs;
    
    point, relativeTo, relativePoint, xOfs, yOfs = PlayerFrame:GetPoint(1);
    positions["PlayerFrame"] = {p=point, rt=relativeTo, rp=relativePoint, x=xOfs, y=yOfs};
    
    point, relativeTo, relativePoint, xOfs, yOfs = TargetFrame:GetPoint(1);
    positions["TargetFrame"] = {p=point, rt=relativeTo, rp=relativePoint, x=xOfs, y=yOfs};
    
    point, relativeTo, relativePoint, xOfs, yOfs = FocusFrame:GetPoint(1);
    positions["FocusFrame"] = {p=point, rt=relativeTo, rp=relativePoint, x=xOfs, y=yOfs};
    
    CleanUIData.UNITFRAME_CUSTOM_POSITIONS[index] = positions;
end

function CleanUIConfig_LoadCustomUnitFramePosition(index)
    local positions = CleanUIData.UNITFRAME_CUSTOM_POSITIONS[index];
    if (not positions) then
        return;
    end    
    
    local pos;
    
    pos = positions["PlayerFrame"];
    CleanUI_SaveFramePosition(PlayerFrame, pos.p, pos.rt, pos.rp, pos.x, pos.y);
    
    pos = positions["TargetFrame"];
    CleanUI_SaveFramePosition(TargetFrame, pos.p, pos.rt, pos.rp, pos.x, pos.y);
    
    pos = positions["FocusFrame"];
    CleanUI_SaveFramePosition(FocusFrame, pos.p, pos.rt, pos.rp, pos.x, pos.y);
end

function CUIConfig_MonkChiTextureDropDown_Initialize(self)
    local selectedValue = UIDropDownMenu_GetSelectedValue(self);
    
    for i = 1, #MONK_CHI_TEXTURES do
        local info = UIDropDownMenu_CreateInfo();
        info.text = MONK_CHI_TEXTURES[i];
        info.value = i;
        info.func = function()
                CUIConfig_SelectMonkChiTexture(i);
            end
        UIDropDownMenu_AddButton(info);
    end
end

function CUIConfig_StatusBarStyleDropDown_Initialize(self)
	local selectedValue = UIDropDownMenu_GetSelectedValue(self);
	
	for i = 1, #STATUSBAR_STYLE do
        local info = UIDropDownMenu_CreateInfo();
        info.text = STATUSBAR_STYLE[i];
        info.value = i;
        info.func = function()
                CleanUIConfig_ToggleStatusBarStyle(i);
            end
        UIDropDownMenu_AddButton(info);
	end
end

function CUIConfig_TooltipPositionDropDown_Initialize(self)
	local selectedValue = UIDropDownMenu_GetSelectedValue(self);
	
	for i = 1, #TOOLTIPS_POSITION do
        local info = UIDropDownMenu_CreateInfo();
        info.text = TOOLTIPS_POSITION[i];
        info.value = i;
        info.func = function()
                CleanUIConfig_ToggleTooltipPosition(i);
            end
        UIDropDownMenu_AddButton(info);
	end
end

function CleanUIConfig_InterfaceOptionsFrame_Show()
    if ( InterfaceOptionsFrame:IsShown() ) then
        CleanUIConfig_ReloadConfig();
    end

    CUI_CONFIG_SHOWN = true;
end

function CleanUIConfig_InterfaceOptionsFrame_Hide()
    CUI_CONFIG_SHOWN = false;
    
    -- Aufrumen!
    CleanUI_HideCastingBars();
end

function CleanUIConfig_OnEvent(self, event, ...)
    if (event == "CVAR_UPDATE") then
        local name, value = ...;
 	    --DEFAULT_CHAT_FRAME:AddMessage("CVAR_UPDATE   "..name.." = "..value, 1.0, 1.0, 1.0, 1, 10);
    end
end

-- settings

function CleanUIConfig_ToggleTooltipPosition(index)
 	CleanUIData.TOOLTIPS_POSITION = index;
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleStatusBarStyle(index)
 	CleanUIData.STATUSBAR_STYLE = index;
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleScreenshot()
    if (CleanUIData.SCREENSHOT == 1) then
        CleanUIData.SCREENSHOT = 0;
    else
        CleanUIData.SCREENSHOT = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleXpFrame()
    if (CleanUIData.SHOW_XPFRAME == 1) then
        CleanUIData.SHOW_XPFRAME = 0;
    else
        CleanUIData.SHOW_XPFRAME = 1;
    end
    
    CleanUIConfig_ConfigChanged();
    CleanUI_CleanXpFrame();
end

function CleanUIConfig_ToggleOrigXpBar()
    if (CleanUIData.SHOW_ORIG_XPBAR == 1) then
        CleanUIData.SHOW_ORIG_XPBAR = 0;
    else
        CleanUIData.SHOW_ORIG_XPBAR = 1;
    end
    
    CleanUIConfig_ConfigChanged();
    CleanUI_CleanXpFrame();
end

function CleanUIConfig_SelectXpFrameWidth(self)

    if (CleanUIData.XPFRAME_WIDTH ~= self:GetValue()) then
        CleanUIData.XPFRAME_WIDTH = self:GetValue();
        
        CleanUIConfig_ConfigChanged();
        
        if (CleanUIXpFrame) then
            CleanUI_CleanXpFrame();
        end
    end
end

function CleanUIConfig_SelectXpBarHeight(self)

    if (CleanUIData.XPBAR_HEIGHT ~= self:GetValue()) then
        CleanUIData.XPBAR_HEIGHT = self:GetValue();
        
        CleanUIConfig_ConfigChanged();
        
        if (CleanUIXpFrame) then
            CleanUI_CleanXpFrame();
        end
    end
end

function CleanUIConfig_ToggleXpFrame_X_Xmax()
    if (CleanUIData.XPFRAME_X_XMAX == 1) then
        CleanUIData.XPFRAME_X_XMAX = 0;
    else
        CleanUIData.XPFRAME_X_XMAX = 1;
    end
    
    CleanUIConfig_ConfigChanged();
    CleanUI_CleanXpFrame();
end

function CleanUIConfig_ToggleXpFrame_Percent()
    if (CleanUIData.XPFRAME_PERCENT == 1) then
        CleanUIData.XPFRAME_PERCENT = 0;
    else
        CleanUIData.XPFRAME_PERCENT = 1;
    end
    
    CleanUIConfig_ConfigChanged();
    CleanUI_CleanXpFrame();
end

function CleanUIConfig_ToggleXpFrame_MaxLevel()
    if (CleanUIData.XPFRAME_MAXLEVEL == 1) then
        CleanUIData.XPFRAME_MAXLEVEL = 0;
    else
        CleanUIData.XPFRAME_MAXLEVEL = 1;
    end
    
    CleanUIConfig_ConfigChanged();
    CleanUI_CleanXpFrame();
end

function CleanUIConfig_ToggleXpFrame_Unknown()
    if (CleanUIData.XPFRAME_UNKNOWN == 1) then
        CleanUIData.XPFRAME_UNKNOWN = 0;
    else
        CleanUIData.XPFRAME_UNKNOWN = 1;
    end
    
    CleanUIConfig_ConfigChanged();
    CleanUI_CleanXpFrame();
end

function CleanUIConfig_ToggleCleanActionBars()
    if (CleanUIData.CHANGE_ACTIONBARS == 1) then
        CleanUIData.CHANGE_ACTIONBARS = 0;
    else
        CleanUIData.CHANGE_ACTIONBARS = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleMacroNames()
    if (CleanUIData.ACTIONBARS_SHOWMACRONAMES == 1) then
        CleanUIData.ACTIONBARS_SHOWMACRONAMES = 0;
    else
        CleanUIData.ACTIONBARS_SHOWMACRONAMES = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleDeBuffsForActionButtons()
    if (CleanUIData.ACTIONBARS_DEBUFFS == 1) then
        CleanUIData.ACTIONBARS_DEBUFFS = 0;
    else
        CleanUIData.ACTIONBARS_DEBUFFS = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_SelectDeBuffsColor()
    ColorPickerFrame.func = CleanUIConfig_SetDeBuffsColor;
    ColorPickerFrame:SetColorRGB(CleanUIData.ACTIONBARS_DEBUFFS_R, CleanUIData.ACTIONBARS_DEBUFFS_G, CleanUIData.ACTIONBARS_DEBUFFS_B);
    ShowUIPanel(ColorPickerFrame);
end

function CleanUIConfig_SetDeBuffsColor()
    local r,g,b = ColorPickerFrame:GetColorRGB();
    CleanUIData.ACTIONBARS_DEBUFFS_R = r;
    CleanUIData.ACTIONBARS_DEBUFFS_G = g;
    CleanUIData.ACTIONBARS_DEBUFFS_B = b;
    
    _G["CleanUIDeBuffsBarColorExample"]:SetStatusBarColor(CleanUIData.ACTIONBARS_DEBUFFS_R, CleanUIData.ACTIONBARS_DEBUFFS_G, CleanUIData.ACTIONBARS_DEBUFFS_B);
end

function CleanUIConfig_SelectLocationTextColor()
    ColorPickerFrame.func = CleanUIConfig_SetLocationTextColor;
    ColorPickerFrame:SetColorRGB(CleanUIData.TLOC_R, CleanUIData.TLOC_G, CleanUIData.TLOC_B);
    ShowUIPanel(ColorPickerFrame);
end

function CleanUIConfig_SetLocationTextColor()
    local r,g,b = ColorPickerFrame:GetColorRGB();
    CleanUIData.TLOC_R = r;
    CleanUIData.TLOC_G = g;
    CleanUIData.TLOC_B = b;
    
    _G["CUILocationTextColor"]:SetBackdropColor(CleanUIData.TLOC_R, CleanUIData.TLOC_G, CleanUIData.TLOC_B);
end

function CleanUIConfig_ToggleShapeshiftBarBorder()
    if (CleanUIData.ACTIONBARS_SHAPESHIFTBAR_BORDER == 1) then
        CleanUIData.ACTIONBARS_SHAPESHIFTBAR_BORDER = 0;
    else
        CleanUIData.ACTIONBARS_SHAPESHIFTBAR_BORDER = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleActionButtonBorder()
    if (CleanUIData.ACTIONBARS_ACTIONBUTTON_BORDER == 1) then
        CleanUIData.ACTIONBARS_ACTIONBUTTON_BORDER = 0;
    else
        CleanUIData.ACTIONBARS_ACTIONBUTTON_BORDER = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_TogglePetActionBarBorder()
    if (CleanUIData.ACTIONBARS_PETACTIONBAR_BORDER == 1) then
        CleanUIData.ACTIONBARS_PETACTIONBAR_BORDER = 0;
    else
        CleanUIData.ACTIONBARS_PETACTIONBAR_BORDER = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleMasqueForActionButtons()
    if (CleanUIData.MASQUE_ACTIONBUTTONS == 1) then
        CleanUIData.MASQUE_ACTIONBUTTONS = 0;
    else
        CleanUIData.MASQUE_ACTIONBUTTONS = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleRangeIndicatorForActionButtons()
    if (CleanUIData.ACTIONBARS_SHOWRANGEINDICATOR == 1) then
        CleanUIData.ACTIONBARS_SHOWRANGEINDICATOR = 0;
    else
        CleanUIData.ACTIONBARS_SHOWRANGEINDICATOR = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleMasqueForBuffs()
    if (CleanUIData.MASQUE_BUFFS == 1) then
        CleanUIData.MASQUE_BUFFS = 0;
    else
        CleanUIData.MASQUE_BUFFS = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleBiggerDebuffs()
    if (CleanUIData.BIGGER_DEBUFFS == 1) then
        CleanUIData.BIGGER_DEBUFFS = 0;
    else
        CleanUIData.BIGGER_DEBUFFS = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleChangeBags()
    if (CleanUIData.CHANGE_BAGS == 1) then
        CleanUIData.CHANGE_BAGS = 0;
    else
        CleanUIData.CHANGE_BAGS = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleColorizeItems()
    if (CleanUIData.BAGS_COLORIZE_ITEMS == 1) then
        CleanUIData.BAGS_COLORIZE_ITEMS = 0;
    else
        CleanUIData.BAGS_COLORIZE_ITEMS = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleShowWhiteAsGray()
    if (CleanUIData.BAGS_SHOW_WHITE_AS_GRAY == 1) then
        CleanUIData.BAGS_SHOW_WHITE_AS_GRAY = 0;
    else
        CleanUIData.BAGS_SHOW_WHITE_AS_GRAY = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleBagsAutoRepair()
    if (CleanUIData.BAGS_AUTOREPAIR == 1) then
        CleanUIData.BAGS_AUTOREPAIR = 0;
    else
        CleanUIData.BAGS_AUTOREPAIR = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleBagsAutoSellGray()
    if (CleanUIData.BAGS_AUTOSELLGRAY == 1) then
        CleanUIData.BAGS_AUTOSELLGRAY = 0;
    else
        CleanUIData.BAGS_AUTOSELLGRAY = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleChangeCastingBars()
    if (CleanUIData.CHANGE_CASTINGBARS == 1) then
        CleanUIData.CHANGE_CASTINGBARS = 0;
    else
        CleanUIData.CHANGE_CASTINGBARS = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleCastingBarsShowPetBar()
    if (CleanUIData.CASTINGBARS_SHOWPETBAR == 1) then
        CleanUIData.CASTINGBARS_SHOWPETBAR = 0;
    else
        CleanUIData.CASTINGBARS_SHOWPETBAR = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_SelectCastingBarAlpha(self)

    if (CleanUIData.CASTINGBARS_ALPHA ~= self:GetValue()) then
        CleanUIData.CASTINGBARS_ALPHA = self:GetValue();
        
        CleanUIConfig_ConfigChanged();
        
        if (CastingBarFrame and CleanUIPetCastingBarFrame) then
            CleanUI_UpdateCastingBars();
        end
    end
end

function CleanUIConfig_SelectDeBuffsBarHeight(self)

    if (CleanUIData.ACTIONBARS_DEBUFFS_HEIGHT ~= self:GetValue()) then
        CleanUIData.ACTIONBARS_DEBUFFS_HEIGHT = self:GetValue();
        
        CleanUIConfig_ConfigChanged();
    end
end

function CleanUIConfig_SelectCastingBarWidth(self)

    if (CleanUIData.CASTINGBARS_WIDTH ~= self:GetValue()) then
        CleanUIData.CASTINGBARS_WIDTH = self:GetValue();
        
        CleanUIConfig_ConfigChanged();
        
        if (CastingBarFrame and CleanUIPetCastingBarFrame) then
            CleanUI_UpdateCastingBars();
        end
    end
end

function CleanUIConfig_SelectPlayerCastingBarHeight(self)

    if (CleanUIData.CASTINGBARS_PLAYERHEIGHT ~= self:GetValue()) then
        CleanUIData.CASTINGBARS_PLAYERHEIGHT = self:GetValue();
        
        CleanUIConfig_ConfigChanged();
        
        if (CastingBarFrame) then
            CleanUI_UpdateCastingBars();
        end
    end
end

function CleanUIConfig_SelectPlayerCastingBarImageSize(self)

    if (CleanUIData.CASTINGBARS_IMAGESIZE ~= self:GetValue()) then
        CleanUIData.CASTINGBARS_IMAGESIZE = self:GetValue();
        
        CleanUIConfig_ConfigChanged();
        
        if (CastingBarFrame) then
            CleanUI_UpdateCastingBars();
        end
    end
end

function CleanUIConfig_SelectPetCastingBarHeight(self)

    if (CleanUIData.CASTINGBARS_PETHEIGHT ~= self:GetValue()) then
        CleanUIData.CASTINGBARS_PETHEIGHT = self:GetValue();
        
        CleanUIConfig_ConfigChanged();
        
        if (CleanUIPetCastingBarFrame) then
            CleanUI_UpdateCastingBars();
        end
    end
end

function CleanUIConfig_SelectGlobalCooldownHeight(self)

    if (CleanUIData.CASTINGBARS_GLOBALCOOLDOWN_HEIGHT ~= self:GetValue()) then
        CleanUIData.CASTINGBARS_GLOBALCOOLDOWN_HEIGHT = self:GetValue();
        
        CleanUIConfig_ConfigChanged();
        
        if (CleanUIPetCastingBarFrame) then
            CleanUI_UpdateCastingBars();
        end
    end
end

function CleanUIConfig_ToggleCleanMinimap()
    if (CleanUIData.CHANGE_MINIMAP == 1) then
        CleanUIData.CHANGE_MINIMAP = 0;
    else
        CleanUIData.CHANGE_MINIMAP = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_SelectMinimapAlpha(self)

    if (CleanUIData.MINIMAP_ALPHA ~= self:GetValue()) then
        CleanUIData.MINIMAP_ALPHA = self:GetValue();
        
        CleanUIConfig_ConfigChanged();
    end
end

function CleanUIConfig_SelectWatchFrameAlpha(self)

    if (CleanUIData.WATCHFRAME_ALPHA ~= self:GetValue()) then
        CleanUIData.WATCHFRAME_ALPHA = self:GetValue();
        
        CleanUIConfig_ConfigChanged();
    end
end

function CleanUIConfig_ToggleMinimapButtonBar()
    if (CleanUIData.MINIMAP_SHOWBUTTONBAR == 1) then
        CleanUIData.MINIMAP_SHOWBUTTONBAR = 0;
    else
        CleanUIData.MINIMAP_SHOWBUTTONBAR = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleCleanUnitFrames()
    if (CleanUIData.CHANGE_UNITFRAMES == 1) then
        CleanUIData.CHANGE_UNITFRAMES = 0;
    else
        CleanUIData.CHANGE_UNITFRAMES = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleCleanBossFrames()
    if (CleanUIData.CHANGE_BOSSFRAMES == 1) then
        CleanUIData.CHANGE_BOSSFRAMES = 0;
    else
        CleanUIData.CHANGE_BOSSFRAMES = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleCastingBarsShowGlobalCooldown(self)
    if (CleanUIData.CASTINGBARS_GLOBALCOOLDOWN == 1) then
        CleanUIData.CASTINGBARS_GLOBALCOOLDOWN = 0;
    else
        CleanUIData.CASTINGBARS_GLOBALCOOLDOWN = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleCastingBarsShowLatency(self)
    if (CleanUIData.CASTINGBARS_LATENCY == 1) then
        CleanUIData.CASTINGBARS_LATENCY = 0;
    else
        CleanUIData.CASTINGBARS_LATENCY = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CUIConfig_PortraitStyleDropDown_Initialize(self)
	for i = 1, #PORTRAIT_TYPE do
        local info = UIDropDownMenu_CreateInfo();
        info.text = PORTRAIT_TYPE[i];
        info.value = i;
        info.func = function()
                CUIConfig_SelectPortraitStyle(i);
            end
        UIDropDownMenu_AddButton(info);
	end
end

function CUIConfig_SelectPortraitStyle(index)
    CleanUIData.PORTRAIT_STYLE = index;
    UIDropDownMenu_SetSelectedValue(CUIConfig_PortraitStyleDropDown, index);
    
    CleanUIConfig_ConfigChanged();
    CleanUI_UpdateAllPortraits();
end

function CUIConfig_SelectMonkChiTexture(index)
    CleanUIData.MONK_CHI_TEXTURE_INDEX = index;
    UIDropDownMenu_SetSelectedValue(CUIConfig_MonkChiTextureDropDown, index);
    
    CleanUIConfig_ConfigChanged();
    CleanUI_MonkHarmonyBar_Update();
end

function CleanUIConfig_ToggleMapLevel()
    if (CleanUIData.MAP_SHOWQUESTLEVEL == 1) then
        CleanUIData.MAP_SHOWQUESTLEVEL = 0;
    else
        CleanUIData.MAP_SHOWQUESTLEVEL = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleMapRoutes()
    if (CleanUIData.MAP_SHOWSHIPROUTES == 1) then
        CleanUIData.MAP_SHOWSHIPROUTES = 0;
    else
        CleanUIData.MAP_SHOWSHIPROUTES = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleWayPoints()
    if (CleanUIData.MAP_SHOWWAYPOINTS == 1) then
        CleanUIData.MAP_SHOWWAYPOINTS = 0;
    else
        CleanUIData.MAP_SHOWWAYPOINTS = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleChangeChat()
    if (CleanUIData.CHANGE_CHAT == 1) then
        CleanUIData.CHANGE_CHAT = 0;
    else
        CleanUIData.CHANGE_CHAT = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleDisableAltArrowKeyMode()
    if (CleanUIData.DISABLE_ALTARROWKEYMODE == 1) then
        CleanUIData.DISABLE_ALTARROWKEYMODE = 0;
    else
        CleanUIData.DISABLE_ALTARROWKEYMODE = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleShowChatActionBar()
    if (CleanUIData.SHOW_CHAT_ACTIONBAR == 1) then
        CleanUIData.SHOW_CHAT_ACTIONBAR = 0;
    else
        CleanUIData.SHOW_CHAT_ACTIONBAR = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleShowChatEmoticons()
    if (CleanUIData.SHOW_CHAT_EMOTICONS == 1) then
        CleanUIData.SHOW_CHAT_EMOTICONS = 0;
    else
        CleanUIData.SHOW_CHAT_EMOTICONS = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_SelectChatFontSize(self)
    if (CleanUIData.CHAT_FONT_SIZE ~= self:GetValue()) then
        CleanUIData.CHAT_FONT_SIZE = self:GetValue();
        
        CleanUIConfig_ConfigChanged();
    end
end

function CleanUIConfig_ToggleChangeRaid()
    if (CleanUIData.CHANGE_RAID == 1) then
        CleanUIData.CHANGE_RAID = 0;
    else
        CleanUIData.CHANGE_RAID = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleHideTooltipsInCombat()
    if (CleanUIData.TOOLTIPS_HIDEINCOMBAT == 1) then
        CleanUIData.TOOLTIPS_HIDEINCOMBAT = 0;
    else
        CleanUIData.TOOLTIPS_HIDEINCOMBAT = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleTooltipsBackdrop()
    if (CleanUIData.TOOLTIPS_BACKDROP == 1) then
        CleanUIData.TOOLTIPS_BACKDROP = 0;
    else
        CleanUIData.TOOLTIPS_BACKDROP = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleChangeNameplates()
    if (CleanUIData.CHANGE_NAMEPLATES == 1) then
        CleanUIData.CHANGE_NAMEPLATES = 0;
    else
        CleanUIData.CHANGE_NAMEPLATES = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleNameplatesPercent()
    if (CleanUIData.NAMEPLATES_PERCENT == 1) then
        CleanUIData.NAMEPLATES_PERCENT = 0;
    else
        CleanUIData.NAMEPLATES_PERCENT = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleNameplatesHighlightTarget()
    if (CleanUIData.NAMEPLATES_HIGHLIGHTTARGET == 1) then
        CleanUIData.NAMEPLATES_HIGHLIGHTTARGET = 0;
    else
        CleanUIData.NAMEPLATES_HIGHLIGHTTARGET = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleNameplatesComboPoints()
    if (CleanUIData.NAMEPLATES_SHOWCOMBOPOINTS == 1) then
        CleanUIData.NAMEPLATES_SHOWCOMBOPOINTS = 0;
    else
        CleanUIData.NAMEPLATES_SHOWCOMBOPOINTS = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleNameplatesCombatOnly()
    if (CleanUIData.NAMEPLATES_COMBATONLY == 1) then
        CleanUIData.NAMEPLATES_COMBATONLY = 0;
    else
        CleanUIData.NAMEPLATES_COMBATONLY = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleShowDataBroker()
    if (CleanUIData.SHOW_DATABROKER == 1) then
        CleanUIData.SHOW_DATABROKER = 0;
    else
        CleanUIData.SHOW_DATABROKER = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_SelectDataBrokerCountRows(self)

    if (CleanUIData.DATABROKER_COUNTROWS ~= self:GetValue()) then
        CleanUIData.DATABROKER_COUNTROWS = self:GetValue();
        
        CleanUIConfig_ConfigChanged();
    end
end