

function CleanUI_InitFriendsFrame()    
    CleanUI_FriendsFrameHookEvents();
    CleanUI_RegisterFriendsFrameEvents();
    
    CleanUI_CleanFriendsFrame();
    CleanUI_CleanRaidInfoFrame();
end
    
function CleanUI_RegisterFriendsFrameEvents()
    --local frame = CreateFrame("Frame");
    
    --frame:RegisterEvent("---");
    
    --frame:HookScript("OnEvent", CleanUI_FriendsFrameOnEvent); 
end

function CleanUI_FriendsFrameHookEvents()
    hooksecurefunc("FriendsFrame_Update", CleanUI_FriendsFrame_Update);
end

function CleanUI_FriendsFrameOnEvent(self, event, ...)
    if (event == "---") then
    end
end
    
function CleanUI_FriendsFrame_Update()
    CleanUI_RemoveTextures(FriendsFrame);  
    CleanUI_SetBackdrop(FriendsFrame); 
end
    
function CleanUI_CleanFriendsFrame()
    CleanUI_RemoveTextures(FriendsFrame);  
    CleanUI_SetBackdrop(FriendsFrame); 
    
    FriendsFramePortrait:Hide();
        
    CleanUI_ChangeCloseButton(FriendsFrame);
    
    CleanUI_CreateHeaderFrame(FriendsFrame, "CUI_FriendsFrameHeaderBorderframe", 250, FriendsFrameTitleText);
    
    local tabButton;
    for i=1, 10 do
        tabButton = _G["FriendsFrameTab"..i];
        if (not tabButton) then
            break;
        end
        
        CleanUI_ChangeTab(tabButton);
    end
    
    CleanUI_ChangeButton(FriendsFrameAddFriendButton);
    CleanUI_ChangeButton(FriendsFrameSendMessageButton);
    
    -- WhoFrame
    CleanUI_ChangeButton(WhoFrameWhoButton);
    CleanUI_ChangeButton(WhoFrameAddFriendButton);
    CleanUI_ChangeButton(WhoFrameGroupInviteButton);
    CleanUI_ChangeDropDown(WhoFrameDropDown);  
    
    local header;
    for i=1, 10 do
        header = _G["WhoFrameColumnHeader"..i];
        
        if (header) then 
            CleanUI_ChangeFilterButton(header, true);
        end
    end
    
    CleanUI_RemoveTextures(WhoFrameListInset); 
    CleanUI_RemoveTextures(WhoFrameEditBoxInset); 
    
    -- ChannelFrame
    CleanUI_ChangeButton(ChannelFrameNewButton);
    
    CleanUI_RemoveTextures(ChannelFrame); 
    CleanUI_RemoveTextures(ChannelFrameLeftInset); 
    CleanUI_RemoveTextures(ChannelFrameRightInset); 
    
    CleanUI_RemoveTextures(ChannelRosterScrollFrame); 
    
    local button;
    for i=1, 20 do
        button = _G["ChannelButton"..i];
        
        if (button) then 
            CleanUI_RemoveTextures(button);
        end
    end
    
    -- RaidFrame
    CleanUI_ChangeButton(RaidFrameConvertToRaidButton);
    CleanUI_ChangeButton(RaidFrameRaidBrowserButton);
    CleanUI_ChangeButton(RaidFrameRaidInfoButton);
    
    local raidgroup;
    for i=1, 8 do
        raidgroup = _G["RaidGroup"..i];
        
        if (raidgroup) then 
            CleanUI_RemoveTextures(raidgroup);
        end
    end
    
    -- FriendsFrame
    CleanUI_ChangeButton(FriendsFrameIgnorePlayerButton);
    CleanUI_ChangeButton(FriendsFrameUnsquelchButton);
    
    CleanUI_RemoveTextures(FriendsFrameInset);  
    
    CleanUI_RemoveTextures(FriendsTabHeaderTab1);  
    CleanUI_RemoveTextures(FriendsTabHeaderTab2);  
    CleanUI_RemoveTextures(FriendsTabHeaderTab3);  
    
    CleanUI_RemoveTextures(FriendsFrameFriendsScrollFrame); 
end
    
function CleanUI_CleanRaidInfoFrame()
    CleanUI_RemoveTextures(RaidInfoFrame);  
    CleanUI_SetBackdrop(RaidInfoFrame); 
        
    CleanUI_ChangeCloseButton(RaidInfoFrame, nil, RaidInfoCloseButton);
    
    CleanUI_CreateHeaderFrame(RaidInfoFrame, "CUI_RaidInfoFrameHeaderBorderframe", 250, RaidInfoFrameHeaderText);
    
    CleanUI_ChangeButton(RaidInfoExtendButton);
    CleanUI_ChangeButtonRed(RaidInfoCancelButton);
    
    RaidInfoExtendButton:SetPoint("BOTTOMLEFT", 8, 8);
    RaidInfoCancelButton:SetPoint("BOTTOMRIGHT", -8, 8);
    
    RaidInfoScrollFrameScrollBarBG:Hide();
    RaidInfoScrollFrameScrollBarTop:Hide();
    RaidInfoScrollFrameScrollBarBottom:Hide();
    RaidInfoScrollFrameScrollBarMiddle:Hide();
    
    CleanUI_RemoveTextures(RaidInfoInstanceLabel);  
    CleanUI_SetBackdrop(RaidInfoInstanceLabel); 
    CleanUI_RemoveTextures(RaidInfoIDLabel);  
    CleanUI_SetBackdrop(RaidInfoIDLabel);
end
