local durability = "";
local itemlevel = "";
local money = "";

local inv_slots = {
	(GetInventorySlotInfo("HeadSlot")),
	(GetInventorySlotInfo("NeckSlot")),
	(GetInventorySlotInfo("ShoulderSlot")),
	(GetInventorySlotInfo("BackSlot")),
	(GetInventorySlotInfo("ChestSlot")),
	(GetInventorySlotInfo("WristSlot")),
	(GetInventorySlotInfo("HandsSlot")),
	(GetInventorySlotInfo("WaistSlot")),
	(GetInventorySlotInfo("LegsSlot")),
	(GetInventorySlotInfo("FeetSlot")),
	(GetInventorySlotInfo("Finger0Slot")),
	(GetInventorySlotInfo("Finger1Slot")),
	(GetInventorySlotInfo("Trinket0Slot")),
	(GetInventorySlotInfo("Trinket1Slot")),
	(GetInventorySlotInfo("MainHandSlot")),
	(GetInventorySlotInfo("SecondaryHandSlot")),
}

local mouseover = 0;
	
local microbutton_names = {
    "CharacterMicroButton",
    "SpellbookMicroButton",
    "TalentMicroButton",
    "AchievementMicroButton",    
    "QuestLogMicroButton",
    
    "GuildMicroButton",
    "PVPMicroButton",
    "LFDMicroButton",    
    "CompanionsMicroButton",
    "EJMicroButton",
    
    "StoreMicroButton",
    "MainMenuMicroButton",
    "HelpMicroButton",
    
    -- CleanUI
    "CUIDataStoreMicroButton",
}

function CleanUI_InitMinimap()
    if (CleanUIData.CHANGE_MINIMAP ~= 1) then 
        CleanUI_CleanMicroButtons();
    else
        CleanUI_CleanMinimap();
        CleanUI_InitMinimapButtons();
    end
    
    CleanUI_MinimapHookEvents();
    CleanUI_RegisterMinimapEvents();
    
    CleanUI_InitMinimapFrameStrata();
    
    money = CleanUI_GetPlayerMoney();
    durability = CleanUI_GetPlayerDurability();
    itemlevel = CleanUI_GetPlayerItemLevel();
end
    
function CleanUI_RegisterMinimapEvents()         
    local frame = CreateFrame("Frame");
    
    frame:RegisterEvent("UPDATE_PENDING_MAIL"); 
    frame:RegisterEvent("MAIL_CLOSED"); 
    frame:RegisterEvent("PLAYER_MONEY"); 
    frame:RegisterEvent("PLAYER_DEAD"); 
    frame:RegisterEvent("UPDATE_INVENTORY_ALERTS"); 
    frame:RegisterEvent("PLAYER_REGEN_ENABLED"); 
    frame:RegisterEvent("UNIT_INVENTORY_CHANGED"); 
    frame:RegisterEvent("UNIT_ENTERED_VEHICLE"); 
    frame:RegisterEvent("UNIT_EXITED_VEHICLE");  
    frame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");  
    frame:RegisterEvent("WORLD_MAP_UPDATE");  
    
    frame:HookScript("OnEvent", CleanUI_MinimapOnEvent); 
end

function CleanUI_MinimapOnEvent(self, event, ...)
    if (CleanUIData.CHANGE_MINIMAP ~= 1) then        
        return;
    end
    
    local arg1 = ...;

    if (event == "UPDATE_PENDING_MAIL" or event == "MAIL_CLOSED") then
        CleanUI_CheckNewMail();
    end
 	
    if (event == "PLAYER_MONEY") then
	    money = CleanUI_GetPlayerMoney();
	end
 	
	if (event == "PLAYER_DEAD" or 
	    event == "UPDATE_INVENTORY_ALERTS" or 
	    event == "PLAYER_REGEN_ENABLED" or 
	    event == "PLAYER_MONEY" or 
	    event == "UNIT_INVENTORY_CHANGED") then
	    durability = CleanUI_GetPlayerDurability();
	    itemlevel = CleanUI_GetPlayerItemLevel();
 	end
    
    if ((event == "UNIT_ENTERED_VEHICLE" or event == "UNIT_EXITED_VEHICLE") and (arg1 == "player")) then
        CleanUI_HideMicroButtons();
    end
    
    if (event == "ACTIVE_TALENT_GROUP_CHANGED" or 
        event == "WORLD_MAP_UPDATE") then
        CleanUI_HideMicroButtons();
    end
end

function CleanUI_CheckNewMail()
    if (HasNewMail()) then
        CleanUI_ShowMinimapButtons();
    else
        CleanUI_HideMinimapButtons();
    end
end

function CleanUI_MinimapHookEvents()

    -- FishingBuddy-Hotfix
    if (ToggleMinimap) then
        hooksecurefunc("ToggleMinimap", CleanUI_ToggleMinimap);
    end
    
    hooksecurefunc("UpdateMicroButtons", CleanUI_UpdateMicroButtons); 
end

function CleanUI_ToggleMinimap()
    if(Minimap:IsShown()) then
        MinimapCluster:Show();
    else
        MinimapCluster:Hide();
    end
end

function CleanUI_UpdateMicroButtons()
    CleanUI_CleanMicroButtons();		

	if ( CleanUIDataStoreFrame and CleanUIDataStoreFrame:IsShown() ) then
		CUIDataStoreMicroButton:SetButtonState("PUSHED", 1);
	else
		CUIDataStoreMicroButton:SetButtonState("NORMAL");
	end
    
    if (mouseover == 1) then
    	CleanUI_RelocateMicroButtons();
    end
end

function CleanUI_CleanMicroButtons()
    
    CleanUIMicroButtonFrame:Show();
    
    CleanUIMicroButtonFrame:SetClampedToScreen(true);
    CleanUIMicroButtonFrame:SetWidth(312);
    CleanUIMicroButtonFrame:SetHeight(44);
    
    CleanUI_SetBackdrop(CleanUIMicroButtonFrame);
    
    CharacterMicroButton:ClearAllPoints();
    CharacterMicroButton:SetPoint("LEFT", CleanUIMicroButtonFrame, "LEFT", 4, 10);
    
    -- talent alert
    TalentMicroButtonAlert:SetParent(CleanUIMinimapBorderBottom);
    TalentMicroButtonAlert:ClearAllPoints();
    TalentMicroButtonAlert:SetPoint("TOPRIGHT", CleanUIMinimapBorderBottom, "BOTTOMRIGHT", 0, -4);
    
    CleanUI_RemoveTextures(TalentMicroButtonAlert);
    TalentMicroButtonAlert.Arrow:Hide();    
    CleanUI_SetBackdrop(TalentMicroButtonAlert);
    TalentMicroButtonAlert:SetBackdropColor(1.0, 1.0, 0.0, 1.0);
    
    TalentMicroButtonAlert.CloseButton:ClearAllPoints();
    TalentMicroButtonAlert.CloseButton:SetPoint("TOPRIGHT", TalentMicroButtonAlert, "TOPRIGHT", 0, 0);    
    
    -- companions alert
    CompanionsMicroButtonAlert:SetParent(CleanUIMinimapBorderBottom);
    CompanionsMicroButtonAlert:ClearAllPoints();
    CompanionsMicroButtonAlert:SetPoint("TOPRIGHT", CleanUIMinimapBorderBottom, "BOTTOMRIGHT", 0, -4);
    
    CleanUI_RemoveTextures(CompanionsMicroButtonAlert);
    CompanionsMicroButtonAlert.Arrow:Hide();    
    CleanUI_SetBackdrop(CompanionsMicroButtonAlert);
    CompanionsMicroButtonAlert:SetBackdropColor(1.0, 1.0, 0.0, 1.0);
    
    CompanionsMicroButtonAlert.CloseButton:ClearAllPoints();
    CompanionsMicroButtonAlert.CloseButton:SetPoint("TOPRIGHT", TalentMicroButtonAlert, "TOPRIGHT", 0, 0);    
end

function CleanUI_CleanMinimap()
    
    CleanUIMicroButtonFrame:Hide();
    
    CleanUI_SetBackdrop(CleanUIMinimapBorder);    
    CleanUI_SetBackdrop(CleanUIMinimapButtons);    
    CleanUI_SetBackdrop(CleanUIMinimapDataBroker);
    
    CleanUIMinimapBorder:Show();
    CleanUIMinimapBorderTop:Show();
    CleanUIMinimapBorderBottom:Show();
    CleanUIMinimapButtons:Show();
    CleanUIMinimapDataBroker:Show();

    --Minimap:SetMaskTexture("Interface/Buttons/WHITE8x8");
    Minimap:SetMaskTexture("Interface\\AddOns\\CleanUI\\skins\\minimap_masktexture");
	MinimapBorder:Hide();
	MinimapBorderTop:Hide();
	
	Minimap:SetSize(137, 137);
	Minimap:SetPoint("CENTER", MinimapCluster, "TOP", 9, -93); 
    
    CleanUI_InitMinimapRightButtons();
	
    TimeManagerClockButton:GetRegions():Hide();	
    TimeManagerClockButton:ClearAllPoints();
    TimeManagerClockButton:SetWidth(35);
    TimeManagerClockButton:SetPoint("TOPRIGHT", CleanUIMinimapBorderBottom, "TOPRIGHT", -5, 2.5);
    
    GameTimeFrame:ClearAllPoints();
    GameTimeFrame:SetPoint("RIGHT", TimeManagerClockButton, "LEFT", 0, 2);
    GameTimeFrame:SetScale(0.5);
    GameTimeFrame:GetNormalTexture():SetTexCoord(0, 1, 0, 1);
    GameTimeFrame:GetNormalTexture():SetTexture("Interface\\Addons\\CleanUI\\skins\\minimap\\calendar");
    GameTimeFrame:GetPushedTexture():SetTexCoord(0, 1, 0, 1);
    GameTimeFrame:GetPushedTexture():SetTexture("Interface\\Addons\\CleanUI\\skins\\minimap\\calendar");
    GameTimeFrame:SetNormalFontObject("GameFontNormalHugeBlack");

    MinimapZoneTextButton:SetWidth(CleanUIMinimapBorderTop:GetWidth());
    MinimapZoneTextButton:SetHeight(CleanUIMinimapBorderTop:GetHeight());
    
    MinimapZoneTextButton:ClearAllPoints();
    MinimapZoneTextButton:SetPoint("TOPLEFT", CleanUIMinimapBorderTop, "TOPLEFT", 0, 0); 
    MinimapZoneTextButton:SetPoint("BOTTOMRIGHT", CleanUIMinimapBorderTop, "BOTTOMRIGHT", 0, 0); 
    
    MinimapZoneText:ClearAllPoints();
    MinimapZoneText:SetPoint("TOPLEFT", CleanUIMinimapBorderTop, "TOPLEFT", 0, 0); 
    MinimapZoneText:SetPoint("BOTTOMRIGHT", CleanUIMinimapBorderTop, "BOTTOMRIGHT", 0, 0); 

    MiniMapInstanceDifficulty:ClearAllPoints();
    MiniMapInstanceDifficulty:SetPoint("TOPRIGHT", MinimapCluster, "TOPRIGHT", -18, -16); 
    MiniMapInstanceDifficulty:SetFrameStrata("HIGH");
    
    GuildInstanceDifficulty:ClearAllPoints();
    GuildInstanceDifficulty:SetPoint("TOPRIGHT", MinimapCluster, "TOPRIGHT", -18, -16); 
    GuildInstanceDifficulty:SetFrameStrata("HIGH");
    
    MiniMapVoiceChatFrame:ClearAllPoints();
    MiniMapVoiceChatFrame:SetPoint("TOPLEFT", MinimapCluster, "BOTTOMLEFT", 30, 55);
    MiniMapVoiceChatFrameBackground:Hide();
    MiniMapVoiceChatFrameBorder:Hide();
    
    MiniMapRecordingButton:ClearAllPoints(); 
    MiniMapRecordingButton:SetPoint("TOPLEFT", MinimapCluster, "BOTTOMLEFT", 50, 55);
    MiniMapRecordingBorder:Hide();
    
    CleanUI_SetBackdrop(CleanUIMinimapBorderTop);
    
    CleanUIMinimapBorderBottom:SetFrameStrata("BACKGROUND");
    
    CleanUI_SetBackdrop(CleanUIMinimapBorderBottom);

	for ii=1, #(microbutton_names), 1 do
	    local button = _G[microbutton_names[ii]];
	    
	    if (button) then
		    button:HookScript("OnEnter", CleanUI_MicroButtonMouseOver);
		    button:HookScript("OnLeave", CleanUI_MicroButtonMouseOut);
		    button:HookScript("OnClick", CleanUI_RelocateMicroButtons);
		    
		    button:SetFrameStrata("DIALOG");
	    end
    end
    
    --HelpOpenTicketButton:HookScript("OnEnter", CleanUI_MicroButtonMouseOver);
    --HelpOpenTicketButton:HookScript("OnLeave", CleanUI_MicroButtonMouseOut);
    
    --HelpOpenWebTicketButton:HookScript("OnEnter", CleanUI_MicroButtonMouseOver);
    --HelpOpenWebTicketButton:HookScript("OnLeave", CleanUI_MicroButtonMouseOut);
    
    -- move help buttons
    HelpOpenTicketButton:ClearAllPoints(); 
    HelpOpenTicketButton:SetPoint("TOPRIGHT", CleanUIMinimapBorderBottom, "BOTTOMRIGHT", -25, 3);
    
    HelpOpenWebTicketButton:ClearAllPoints(); 
    HelpOpenWebTicketButton:SetPoint("TOPRIGHT", CleanUIMinimapBorderBottom, "BOTTOMRIGHT", 0, 3);
    
    -- move buttons
	CleanUI_RelocateMicroButtons();
	CleanUI_HideMinimapInformation();
    
    if (HasNewMail()) then
        CleanUI_ShowMinimapButtons();
    else
        CleanUI_HideMinimapButtons();
    end 
          
    CleanUI_CleanTimeManager();
    
    CleanUI_UpdateMinimap();
end

function CleanUI_CleanTimeManager()
	CleanUI_RemoveTextures(TimeManagerFrame);
	CleanUI_SetBackdrop(TimeManagerFrame); 
	
	CleanUI_ChangeCloseButton(TimeManagerFrame);
	
	CleanUI_RemoveTextures(TimeManagerFrameInset);
	
	CleanUI_ChangeDropDown(TimeManagerAlarmHourDropDown);
	CleanUI_ChangeDropDown(TimeManagerAlarmMinuteDropDown);
	CleanUI_ChangeDropDown(TimeManagerAlarmAMPMDropDown);
	
	CleanUI_ChangeEditBox(TimeManagerAlarmMessageEditBox, 30, -10, 5);
	
	CleanUI_RemoveTextures(StopwatchFrame);
end

function CleanUI_UpdateMinimap()    
    MinimapCluster:SetAlpha(CleanUIData.MINIMAP_ALPHA);

    if (InCombatLockdown()) then
    	return;
	end
	
    local xoffset = 2;
    local yoffset = -10 + CleanUI_GetTitanYOffset();

    if (CleanUIData.MINIMAP_SHOWBUTTONBAR == 1) then
        xoffset = 39;
        CleanUIMinimapRightButtonFrame:Show();
    else
        CleanUIMinimapRightButtonFrame:Hide();
    end    
    
    MinimapCluster:ClearAllPoints();
    MinimapCluster:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", 10 - xoffset, yoffset);
    
    BuffFrame:ClearAllPoints();        
    BuffFrame:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", -190 - xoffset, yoffset);
end

function CleanUI_InitMinimapRightButtons()   
    local button;
    local parent = _G["CleanUIMinimapRightButtonFrame"];
    local rel = "TOPLEFT";
    
    for i=1, 5 do
    	button = _G["CleanUIMinimapRightButtonFrameButton"..i];
    	
    	if (not button) then
    	    button = CreateFrame("Button", "CleanUIMinimapRightButtonFrameButton"..i, _G["CleanUIMinimapRightButtonFrame"], "CleanUIMinimapButtonTemplate");
    
            button:RegisterEvent("ACTIONBAR_UPDATE_USABLE");
            button:RegisterEvent("ACTIONBAR_UPDATE_COOLDOWN");
    
            local icon = _G[button:GetName().."Icon"];
            icon:SetDrawLayer("ARTWORK");
            icon:ClearAllPoints();
            icon:SetPoint("TOPLEFT", button, "TOPLEFT", 4, -4); 
            icon:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", -4, 4); 
            
            button:GetPushedTexture():ClearAllPoints();
            button:GetPushedTexture():SetPoint("TOPLEFT", button, "TOPLEFT", 2, -2); 
            button:GetPushedTexture():SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", -2, 2);   
            
            button:GetHighlightTexture():ClearAllPoints();
            button:GetHighlightTexture():SetPoint("TOPLEFT", button, "TOPLEFT", -1, 1); 
            button:GetHighlightTexture():SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", 1, -1);
            
            local cooldown = _G[button:GetName().."Cooldown"];   
            cooldown:ClearAllPoints();
            cooldown:SetPoint("TOPLEFT", button, "TOPLEFT", 4, -4); 
            cooldown:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", -4, 4); 
    	end
    	
    	button:SetAttribute("index", i);
    	
        CleanUI_SetBackdrop(button);
        
        button:SetSize(40, 40);
        
        button:ClearAllPoints();
        button:SetPoint("TOPLEFT", parent, rel, 0, 4);  
          
        parent = button;
        rel = "BOTTOMLEFT"; 
    end
    
    CleanUI_StartDelay(3, CleanUI_InitMinimapRightButtons_LoadItems);     
end

function CleanUI_InitMinimapRightButtons_LoadItems() 
    if (InCombatLockdown()) then      
    	CleanUI_StartDelay(20, CleanUI_InitMinimapRightButtons_LoadItems); 
    	return;
    end 

    local button, icon, index, id;
    local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice;
    
    for i=1, 5 do
        button = _G["CleanUIMinimapRightButtonFrameButton"..i];
        icon = _G[button:GetName().."Icon"];
        
        index = button:GetAttribute("index");
        id = CleanUIData.MINIMAP_RIGHTBUTTONS[index];
        
        if (id) then
            itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(id);
            button:SetAttribute("type", "item");
            button:SetAttribute("item", itemName);
            button:SetAttribute("itemId", id);
            button:SetAttribute("itemLink", itemLink);
            icon:SetTexture(itemTexture);
            icon:SetTexCoord(0.1, 0.9, 0.1, 0.9);
        else
            button:SetAttribute("type", nil);
            button:SetAttribute("item", nil);
            button:SetAttribute("itemId", nil);
            button:SetAttribute("itemLink", nil);
            icon:SetTexture(nil);
        end
            
        CleanUI_MinimapButton_UpdateUsable(button);
        CleanUI_MinimapButton_UpdateCooldowns(button);
    end
end

function CleanUI_MinimapButton_OnDragStart(self, button)
    if (InCombatLockdown()) then
        return;
    end
    
    if (button == "LeftButton") then
        local id = self:GetAttribute("itemId");
        
        if (id) then
            PickupItem(id);
    
            local index = self:GetAttribute("index");            
            CleanUIData.MINIMAP_RIGHTBUTTONS[index] = nil;
            
            CleanUI_InitMinimapRightButtons_LoadItems();
        end
    end
end

function CleanUI_MinimapButton_OnReceiveDrag(self)
    if (InCombatLockdown()) then
        return;
    end
    
    local type, id, itemLink = GetCursorInfo();
    
    if (type ~= "item") then
        return;
    end
    
    self:Disable();
    
    local index = self:GetAttribute("index");    
    CleanUIData.MINIMAP_RIGHTBUTTONS[index] = id;
    
    ClearCursor();
    CleanUI_InitMinimapRightButtons_LoadItems();
    
    self:Enable();
end

function CleanUI_MinimapButton_OnEnter(self)   
    local itemLink = self:GetAttribute("itemLink");
    
    if (itemLink) then
        GameTooltip_SetDefaultAnchor(GameTooltip, self);
        GameTooltip:SetHyperlink(itemLink);
        GameTooltip:AppendText("");                           
        GameTooltip:Show();
    end
end

function CleanUI_MinimapButton_OnLeave(self)
    GameTooltip:FadeOut();   
end

function CleanUI_MinimapButton_OnUpdate(self, elapsed)        
    CleanUI_MinimapButton_UpdateCooldowns(self);
    CleanUI_MinimapButton_UpdateUsable(self);
end

function CleanUI_MinimapButton_OnButtonEvent(self, event, ...)
    if ( event == "ACTIONBAR_UPDATE_USABLE" ) then
        CleanUI_MinimapButton_UpdateUsable(self);
    elseif ( event == "ACTIONBAR_UPDATE_COOLDOWN" ) then
        CleanUI_MinimapButton_UpdateCooldowns(self);
    end
end

function CleanUI_MinimapButton_UpdateUsable(self)
    local item = self:GetAttribute("item");
    local icon = _G[self:GetName().."Icon"];
    local count = GetItemCount(item, nil, true); 
    local counttext = _G[self:GetName().."Count"];
    
    if (count == 0) then        
        icon:SetVertexColor(0.3, 0.3, 0.3);
    else            
        icon:SetVertexColor(1.0, 1.0, 1.0);
    end
    
    if (count == 0) then
        counttext:SetText("");
    else
        counttext:SetText(count); 
    end
end

function CleanUI_MinimapButton_UpdateCooldowns(self)    
    local item = self:GetAttribute("item");        
    local cooldown = _G[self:GetName().."Cooldown"];    
    local id = self:GetAttribute("itemId");
    
    if (id) then
        local start, duration, enable = GetItemCooldown(id);
    
        if (cooldown and start and duration and enable) then
            CooldownFrame_SetTimer(cooldown, start, duration, enable);
        end
    end
end

function CleanUI_RelocateMicroButtons()    
    local parent;
    
    CharacterMicroButton:ClearAllPoints();
    CharacterMicroButton:SetPoint("TOPLEFT", CleanUIMinimapBorderBottom, "TOPLEFT", 5, -75);
    SpellbookMicroButton:SetPoint("BOTTOMLEFT", CharacterMicroButton, "BOTTOMRIGHT", -1, 0);
    TalentMicroButton:SetPoint("BOTTOMLEFT", SpellbookMicroButton, "BOTTOMRIGHT", -1, 0);
    AchievementMicroButton:SetPoint("BOTTOMLEFT", TalentMicroButton, "BOTTOMRIGHT", -1, 0);
    QuestLogMicroButton:SetPoint("BOTTOMLEFT", AchievementMicroButton, "BOTTOMRIGHT", -1, 0);
        
    GuildMicroButton:ClearAllPoints();
    GuildMicroButton:SetPoint("TOPLEFT", CleanUIMinimapBorderBottom, "TOPLEFT", 5, -110);
    PVPMicroButton:SetPoint("BOTTOMLEFT", GuildMicroButton, "BOTTOMRIGHT", -1, 0);
    LFDMicroButton:SetPoint("BOTTOMLEFT", PVPMicroButton, "BOTTOMRIGHT", -1, 0);
    EJMicroButton:SetPoint("BOTTOMLEFT", LFDMicroButton, "BOTTOMRIGHT", -1, 0);
    CompanionsMicroButton:SetPoint("BOTTOMLEFT", EJMicroButton, "BOTTOMRIGHT", -1, 0);
    
    CUIDataStoreMicroButton:ClearAllPoints();
    CUIDataStoreMicroButton:SetPoint("TOPLEFT", CleanUIMinimapBorderBottom, "TOPLEFT", 5, -145);    
    StoreMicroButton:SetPoint("BOTTOMLEFT", CUIDataStoreMicroButton, "BOTTOMRIGHT", -1, 0);    
    MainMenuMicroButton:SetPoint("BOTTOMLEFT", StoreMicroButton, "BOTTOMRIGHT", -1, 0);
    HelpMicroButton:SetPoint("BOTTOMLEFT", MainMenuMicroButton, "BOTTOMRIGHT", -1, 0);
    
    -- fix
    StoreMicroButton:Show();
end

function CleanUI_HideMicroButtons()

    if (mouseover == 1) then
        CleanUI_RelocateMicroButtons();
        return;
    end

    CharacterMicroButton:ClearAllPoints();
    CharacterMicroButton:SetPoint("TOPLEFT", CleanUIMinimapBorderBottom, "TOPLEFT", 100009, -75);
    GuildMicroButton:ClearAllPoints();
    GuildMicroButton:SetPoint("TOPLEFT", CleanUIMinimapBorderBottom, "TOPLEFT", 100009, -110);
    CUIDataStoreMicroButton:ClearAllPoints();
    CUIDataStoreMicroButton:SetPoint("TOPLEFT", CleanUIMinimapBorderBottom, "TOPLEFT", 100009, -145);
end

function CleanUI_MicroButtonMouseOver(self)
	CleanUI_ShowMinimapInformation();
end

function CleanUI_MicroButtonMouseOut(self)
	CleanUI_HideMinimapInformation();
end

function CleanUI_InitMinimapButtons()
    
    -- die berschrift startet die Map
    local minimapZoneTextButton = _G["MinimapZoneTextButton"];
	minimapZoneTextButton:SetScript("OnClick", CleanUI_ToggleWorldMapFrame);
	minimapZoneTextButton:RegisterForClicks("AnyUp");
    
    -- MapButton entfernen
    MiniMapWorldMapButton:Hide();

	-- Tracking
    MiniMapTracking:SetParent(CleanUIMinimapButtons);
    MiniMapTracking:ClearAllPoints();
    MiniMapTracking:SetPoint("TOP", CleanUIMinimapButtons, "TOP", 0, -2);
    MiniMapTrackingButton:HookScript("OnEnter", CleanUI_ShowMinimapButtons);
    MiniMapTrackingButton:HookScript("OnLeave", CleanUI_HideMinimapButtons);
    MiniMapTrackingButtonBorder:Hide();
    MiniMapTrackingBackground:Hide();
    MiniMapTrackingIcon:SetTexture("Interface\\Addons\\CleanUI\\skins\\minimap\\tracking");
    
    -- Backpack button
    CUIBackpackMinimapButton:SetParent(CleanUIMinimapButtons);
    CUIBackpackMinimapButton:ClearAllPoints();
    CUIBackpackMinimapButton:SetPoint("TOP", CleanUIMinimapButtons, "TOP", 0, -33);
    CUIBackpackMinimapButton:SetScale(0.85);
    CUIBackpackMinimapButtonIcon:SetTexCoord(0.08, 0.92, 0.08, 0.92);
    CUIBackpackMinimapButton:HookScript("OnEnter", CleanUI_ShowMinimapButtons);
    CUIBackpackMinimapButton:HookScript("OnLeave", CleanUI_HideMinimapButtons);
    
    -- MailButton
    MiniMapMailFrame:SetParent(CleanUIMinimapButtons);
    MiniMapMailFrame:ClearAllPoints();
    MiniMapMailFrame:SetPoint("TOP", CleanUIMinimapButtons, "TOP", 0, -42);
    MiniMapMailFrame:SetScale(1.15);
    MiniMapMailFrame:HookScript("OnEnter", CleanUI_ShowMinimapButtons);
    MiniMapMailFrame:HookScript("OnLeave", CleanUI_HideMinimapButtons);
    MiniMapMailIcon:SetTexture("Interface\\Addons\\CleanUI\\skins\\minimap\\mail");
    MiniMapMailBorder:Hide();
    
    -- QueueStatus
    QueueStatusMinimapButton:SetParent(CleanUIMinimapButtons);
    QueueStatusMinimapButton:ClearAllPoints();
    QueueStatusMinimapButton:SetPoint("BOTTOM", CleanUIMinimapButtons, "BOTTOM", 0, 0);
    QueueStatusMinimapButton:HookScript("OnEnter", CleanUI_ShowMinimapButtons);
    QueueStatusMinimapButton:HookScript("OnLeave", CleanUI_HideMinimapButtons);
    QueueStatusMinimapButton:SetHighlightTexture(nil);
    
    QueueStatusMinimapButtonBorder:Hide();

    CleanUI_RemoveTextures(QueueStatusFrame);  
    CleanUI_SetBackdrop(QueueStatusFrame);  
    
    QueueStatusFrame:SetPoint("TOPRIGHT", QueueStatusMinimapButton, "TOPLEFT", -1, 0);
    
    if (MinimapButtonFrame) then
		CleanUI_RemoveTextures(MinimapButtonFrame);
		CleanUI_SetBackdrop(MinimapButtonFrame);  
	end
end
    
local UPDATE_WAIT = 0.5;
local _WaitTimeSinceLast = 0;
function CleanUI_MinimapOnUpdate(self, elapsed)
    if (CleanUIData.CHANGE_MINIMAP ~= 1) then 
        return;
    end
    
    if (_WaitTimeSinceLast <= 0) then
        CleanUI_MinimapUpdate();
        _WaitTimeSinceLast = UPDATE_WAIT;
    else
        _WaitTimeSinceLast = _WaitTimeSinceLast - elapsed;
    end
end
    
function CleanUI_MinimapUpdate()

	local player_x, player_y = CleanUI_GetPlayerPosition();
	
	CleanUIMinimapBorderBottom_tlocx:SetText(player_x);
	CleanUIMinimapBorderBottom_tlocy:SetText(player_y);
	CleanUIMinimapBorderBottom_money:SetText(money);
	CleanUIMinimapBorderBottom_durability:SetText(durability);
	CleanUIMinimapBorderBottom_itemlevel:SetText(itemlevel);
	
	-- work around
	if (mouseover == 0) then
	    TalentMicroButton:Hide();
	end
end

function CleanUI_GetPlayerPosition()
	local x, y = GetPlayerMapPosition("player");
	
	x = x * 100;
	y = y * 100;
    
    local color = cui_rgb2hex(CleanUIData.TLOC_R, CleanUIData.TLOC_G, CleanUIData.TLOC_B);
	
	return "|cff"..color..string.format("%.1f", x).."|r", "|cff"..color..string.format("%.1f", y).."|r";
end

function CleanUI_GetPlayerMoney()
	local money = GetMoney();
	return "|cffffffff"..GetCoinTextureString(money).."|r";
end

function CleanUI_GetPlayerDurability()
	local total = 0;
	local count = 0;
	local color = "00ff00";

	for i = 1, #inv_slots do
		local dur = CleanUI_GetItemDurability(inv_slots[i]);
		
		if (dur >= 0) then
			total = total + dur;
			count = count + 1;
		end
	end
	
	if (count == 0) then
		total = 100;
	else	
	    total = floor(total / count * 100);
	end
	
	if (total > 66) then
		color = "00ff00";
	elseif (total > 19) then 
		color = "ffff00"
	else
		color = "ff0000"
	end
	
	return DURABILITY..": |cff"..color..total.." %|r";
end

function CleanUI_GetItemDurability(slot)
	if (not GetInventoryItemLink("player", slot)) then
		return -1;
	end
	
	local durability, maximum = GetInventoryItemDurability(slot);
	
	if (not durability or (maximum == 0)) then
		return -1;
	end
	
	return durability / maximum;
end

function CleanUI_GetPlayerItemLevel()

    local avgItemLevel, avgItemLevelEquipped = GetAverageItemLevel();
    avgItemLevel = floor(avgItemLevel);
    avgItemLevelEquipped = floor(avgItemLevelEquipped);

	local min = 0;

	for i = 1, #inv_slots do
		local itemLevel = CleanUI_GetItemLevel(inv_slots[i]);
		
		if (itemLevel >= 0) then
		    if (min == 0 or itemLevel < min) then
		        min = itemLevel;
		    end
		end
	end
	
	return "|cffffffff"..avgItemLevelEquipped.." / "..avgItemLevel.." (min. "..min..")|r";
end

function CleanUI_GetItemLevel(slot)
	if (not GetInventoryItemLink("player", slot)) then
		return -1;
	end
	
	local itemLevel = CleanUI_GetSlotItemLevel("player", slot);
	
	if (not itemLevel) then
		return -1;
	end
	
	return itemLevel;
end

function CleanUI_ToggleWorldMapFrame()
    ToggleFrame(WorldMapFrame);
end

function CleanUI_ShowMinimapButtons()
    CleanUIMinimapButtons:SetAlpha(1);
    CleanUIMinimapDataBroker:SetAlpha(1);
end

function CleanUI_HideMinimapButtons()
    CleanUIMinimapButtons:SetWidth(32);
    CleanUIMinimapButtons:SetAlpha(0);
    CleanUI_DataBroker_HideButtons();
    CleanUIMinimapDataBroker:SetAlpha(0);
end

function CleanUI_InitMinimapFrameStrata()
 	CleanUIMinimapBorderTop:SetFrameStrata("LOW");
 	CleanUIMinimapBorder:SetFrameStrata("LOW");
 	
    CleanUIMinimapBorder:SetFrameStrata("BACKGROUND");
 	Minimap:SetFrameStrata("HIGH");
 	MinimapZoneTextButton:SetFrameStrata("HIGH");
 	MiniMapInstanceDifficulty:SetFrameStrata("HIGH");
 	
	for i, child in ipairs({Minimap:GetChildren()}) do
	    child:SetFrameStrata("HIGH");
	end
	
	for i, child in ipairs({MinimapBackdrop:GetChildren()}) do
	    child:SetFrameStrata("HIGH");
	end
end

function CleanUI_ShowMinimapInformation()    
    CleanUIMinimapBorderBottom:SetHeight(210);    
    CleanUIMinimapBorderBottom:SetFrameStrata("LOW");
    
    CleanUIMinimapBorderBottom_money:Show();
    CleanUIMinimapBorderBottom_durability:Show();
    CleanUIMinimapBorderBottom_itemlevel:Show();
    CleanUIMinimapMasterVolume:Show();
    
	for ii=1, #(microbutton_names), 1 do
	    local button = _G[microbutton_names[ii]];
	    
	    if (button) then
	    	button:Show();
	    end
    end
    
    mouseover = 1;
    
    CleanUI_RelocateMicroButtons();
    
	local volume = tonumber(GetCVar("Sound_MasterVolume"));
    CleanUIMinimapMasterVolume:SetValue(volume);
end

function CleanUI_HideMinimapInformation()
    CleanUIMinimapBorderBottom:SetHeight(22);
    CleanUIMinimapBorderBottom:SetFrameStrata("BACKGROUND");
    
    CleanUIMinimapBorderBottom_money:Hide();  
    CleanUIMinimapBorderBottom_durability:Hide();
    CleanUIMinimapBorderBottom_itemlevel:Hide();  
    CleanUIMinimapMasterVolume:Hide();
    
    mouseover = 0;
    
	CleanUI_HideMicroButtons();
end

function CleanUI_MasterVolume_OnLoad(self)
    local name = self:GetName();
    _G[name.."Low"]:Hide();
    _G[name.."High"]:Hide();
    self.label = _G[name .. "Label"];
    self.type = CONTROLTYPE_SLIDER;
    self.cvar = "Sound_MasterVolume";
    self.tooltipText = MASTER_VOLUME;
    self:SetMinMaxValues(0, 1);
    self:SetValueStep(0.1);
    _G[name.."Text"]:SetFontObject("GameFontNormalSmall");
    _G[name.."Text"]:SetPoint("BOTTOM", self, "TOP", 0, 4);
end

function CleanUI_MasterVolume_OnValueChanged(self)
    local value = self:GetValue();

    BlizzardOptionsPanel_SetCVarSafe(self.cvar, value);
    self.label:SetText(tostring(ceil(value * 100)).."%");
    if (self:IsVisible()) then
        PlaySound("igMainMenuOptionCheckBoxOn");
    end
end