-- saved variables
CleanUIPetJournal = {};

local SAFARIHELM_ID = 92738;
local KAMPFHAUSTIERBANDAGE_ID = 86143;

local MAX_ACTIVE_PETS = 3;

-- saved data
CleanUIBattlePetGroups = {};

local selectedIndex = nil;

StaticPopupDialogs["CUI_BATTLEPET_GROUPS_ADD_TITLE_POPUP"] = {
    text = NAME,
    button1 = SAVE,
    button2 = CANCEL,
    OnShow = function (self, data)
        self.editBox:SetText(data or "nil")
    end,
    OnAccept = function (self, data, data2)
        CleanUI_AddPetBattleGroupWithName(self.editBox:GetText())
    end,
    hasEditBox = true,
    timeout = 0,
    whileDead = true,
    hideOnEscape = true,
}

StaticPopupDialogs["CUI_BATTLEPET_GROUPS_RENAME_TITLE_POPUP"] = {
    text = BATTLE_PET_RENAME,
    button1 = SAVE,
    button2 = CANCEL,
    OnShow = function (self, data)
        self.editBox:SetText(data or "nil")
    end,
    OnAccept = function (self, data, data2)
        CleanUI_RenamePetBattleGroupWithName(self.editBox:GetText())
    end,
    hasEditBox = true,
    timeout = 0,
    whileDead = true,
    hideOnEscape = true,
}

function CleanUI_InitPetJournal()  
    CleanUI_RegisterPetJournalEvents();
end
    
function CleanUI_RegisterPetJournalEvents()
    local frame = CreateFrame("Frame");
    
    frame:RegisterEvent("ADDON_LOADED");
    
	frame:RegisterEvent("UNIT_PORTRAIT_UPDATE");
	frame:RegisterEvent("PET_JOURNAL_LIST_UPDATE");
	frame:RegisterEvent("PET_JOURNAL_PET_DELETED");
	frame:RegisterEvent("PET_JOURNAL_PETS_HEALED");
	frame:RegisterEvent("BATTLE_PET_CURSOR_CLEAR");
	frame:RegisterEvent("COMPANION_UPDATE");
	frame:RegisterEvent("PET_BATTLE_LEVEL_CHANGED");
	frame:RegisterEvent("PET_BATTLE_QUEUE_STATUS");
	
	frame:RegisterEvent("BAG_UPDATE");
    
    frame:HookScript("OnEvent", CleanUI_PetJournalOnEvent); 
end

function CleanUI_PetJournalHookEvents()
    hooksecurefunc("PetJournal_UpdatePetList", CleanUI_PetJournal_UpdatePetList);
    
    hooksecurefunc(PetJournalParent, "Show", CleanUI_PetJournal_OnShow);
    hooksecurefunc(PetJournalParent, "Hide", CleanUI_PetJournal_OnHide);
    
	PetJournalListScrollFrame:HookScript("OnVerticalScroll", CleanUI_PetJournal_UpdatePetList)
	PetJournalListScrollFrame:HookScript("OnMouseWheel", CleanUI_PetJournal_UpdatePetList)
end

function CleanUI_PetJournalOnEvent(self, event, ...)
    if (event == "ADDON_LOADED") then
        local addonName = ...;
        if ( addonName == "Blizzard_PetJournal" ) then   
            CleanUI_PetJournalHookEvents();
            CleanUI_CleanPetJournal();
            CleanUI_InitPetBattleGroups();
        end
    end
    if (event == "BAG_UPDATE") then
    	CleanUI_PetJournal_BagUpdate();
    end
        
    CleanUI_BattlePetGroups_OnUpdate();
end
    
function CleanUI_CleanPetJournal()
    CleanUI_RemoveTextures(PetJournalParent);  
    CleanUI_SetBackdrop(PetJournalParent); 
    
    CleanUI_RemoveTextures(PetJournal);  
    CleanUI_RemoveTextures(MountJournal); 
    
    PetJournalTutorialButton:Hide(); 
    PetJournalParentPortrait:Hide();
        
    CleanUI_ChangeCloseButton(PetJournalParent);
    CleanUI_CreateHeaderFrame(PetJournalParent, "CUI_PetJournalParentHeaderBorderframe", 250, PetJournalParentTitleText);
    
    local tabButton;
    for i=1, 10 do
        tabButton = _G["PetJournalParentTab"..i];
        if (not tabButton) then
            break;
        end
        
        CleanUI_ChangeTab(tabButton);
    end
    
    -- PetJournal
    PetJournalListScrollFrameScrollBarBG:Hide(); 
    PetJournalListScrollFrameScrollBarTop:Hide(); 
    PetJournalListScrollFrameScrollBarBottom:Hide(); 
    PetJournalListScrollFrameScrollBarMiddle:Hide();  
    
    CleanUI_RemoveTextures(PetJournal.PetCount); 
    CleanUI_RemoveTextures(PetJournal.LeftInset);   
    CleanUI_RemoveTextures(PetJournal.RightInset);
    
    CleanUI_ChangeEditBox(PetJournalSearchBox, 32, -10, 5);  
    PetJournalSearchBox:SetPoint("TOPLEFT", PetJournal.LeftInset, "TOPLEFT", 15, -5);
    
    PetJournalFilterButtonLeft:Hide();
    PetJournalFilterButtonMiddle:Hide();
    PetJournalFilterButtonRight:Hide();
    
    CleanUI_ChangeButton(PetJournalSummonButton);
    CleanUI_ChangeButton(PetJournalFindBattle);
    
    PetJournalHealPetButton:SetPoint("CENTER", PetJournal, "TOPRIGHT", -28, -42);
    PetJournalHealPetButton.spellname:Hide();
    
    PetJournalHealPetButtonBorder:Hide();
    PetJournalHealPetButtonIconTexture:SetTexCoord(0.05, 0.95, 0.05, 0.95);
	local texture = PetJournalHealPetButton:CreateTexture("PetJournalHealPetButtonCUI_Border", "ARTWORK");
    texture:SetPoint("TOPLEFT", PetJournalHealPetButton, "TOPLEFT", -14, 14);
    texture:SetPoint("BOTTOMRIGHT", PetJournalHealPetButton, "BOTTOMRIGHT", 14, -14);
    texture:SetTexture("Interface\\AddOns\\CleanUI\\skins\\bag\\item_border");
    texture:SetVertexColor(0.3, 0.3, 0.3);
    texture:SetDrawLayer("OVERLAY");
    
    CleanUI_RemoveTextures(PetJournalPetCard);
    CleanUI_RemoveTextures(PetJournalPetCardInset);
    
    local parent, border;
    for i=1, MAX_ACTIVE_PETS do
    	parent = _G["PetJournalLoadoutPet"..i];
    	border = _G["PetJournalLoadoutPet"..i.."QualityBorder"];
    	border:SetTexture("Interface\\AddOns\\CleanUI\\skins\\bag\\item_border");
	    border:SetPoint("TOPLEFT", parent.icon, "TOPLEFT", -12, 12);
	    border:SetPoint("BOTTOMRIGHT", parent.icon, "BOTTOMRIGHT", 12, -14);
    end
    
    PetJournalPetCard.PetInfo.qualityBorder:SetTexture("Interface\\AddOns\\CleanUI\\skins\\bag\\item_border");
	PetJournalPetCard.PetInfo.qualityBorder:SetPoint("TOPLEFT", PetJournalPetCard.PetInfo.icon, "TOPLEFT", -12, 12);
	PetJournalPetCard.PetInfo.qualityBorder:SetPoint("BOTTOMRIGHT", PetJournalPetCard.PetInfo.icon, "BOTTOMRIGHT", 12, -14);
    
    -- button for 'Kampfhaustierbandage'
    local button = CreateFrame("Button", "CUI_KampfhaustierbandageButton", PetJournal, "PetJournalActionButtonTemplate");
    CUI_KampfhaustierbandageButton:GetNormalTexture():SetTexCoord(0.05, 0.95, 0.05, 0.95);
    CUI_KampfhaustierbandageButton:GetNormalTexture():SetTexture("Interface\\Icons\\INV_Misc_Bandage_05");
	button:SetPoint("RIGHT", PetJournalHealPetButton, "LEFT", -4, 0);
	texture = button:CreateTexture("CUI_KampfhaustierbandageButtonBorderTexture", "ARTWORK");
    texture:SetPoint("TOPLEFT", button, "TOPLEFT", -14, 14);
    texture:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", 14, -14);
    texture:SetTexture("Interface\\AddOns\\CleanUI\\skins\\bag\\item_border");
    texture:SetVertexColor(0.3, 0.3, 0.3);
    texture:SetDrawLayer("OVERLAY");
    
    button:RegisterForClicks("AnyUp");
	button:SetAttribute("unit", "player");
	button:SetAttribute("type", "macro");
	button:SetAttribute("macrotext", "/use item:"..KAMPFHAUSTIERBANDAGE_ID);
	
    button:HookScript("OnEnter", CleanUI_PetJournal_ShowKampfhaustierbandageTooltip);
    button:HookScript("OnLeave", CleanUI_PetJournal_HideTooltip);
    
    -- button for 'Safarihelm'
    button = CreateFrame("Button", "CUI_SafarihelmButton", PetJournal, "PetJournalActionButtonTemplate");
    CUI_SafarihelmButton:GetNormalTexture():SetTexCoord(0.05, 0.95, 0.05, 0.95);
    CUI_SafarihelmButton:GetNormalTexture():SetTexture("Interface\\Icons\\INV_HELM_CLOTH_PETSAFARI_A_01");
	button:SetPoint("RIGHT", PetJournalHealPetButton, "LEFT", -41, 0);
	texture = button:CreateTexture("CUI_SafarihelmButtonBorderTexture", "ARTWORK");
    texture:SetPoint("TOPLEFT", button, "TOPLEFT", -14, 14);
    texture:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", 14, -14);
    texture:SetTexture("Interface\\AddOns\\CleanUI\\skins\\bag\\item_border");
    texture:SetVertexColor(0.3, 0.3, 0.3);
    texture:SetDrawLayer("OVERLAY");
    
    button:RegisterForClicks("AnyUp");
    button:HookScript("OnClick", CleanUI_PetJournal_UseSafarihelm);
	
    button:HookScript("OnEnter", CleanUI_PetJournal_ShowSafarihelmTooltip);
    button:HookScript("OnLeave", CleanUI_PetJournal_HideTooltip);
    
    -- chekc button visibility
    CleanUI_PetJournal_BagUpdate();
    
    -- MountJournal
    MountJournalListScrollFrameScrollBarBG:Hide(); 
    MountJournalListScrollFrameScrollBarTop:Hide(); 
    MountJournalListScrollFrameScrollBarBottom:Hide(); 
    MountJournalListScrollFrameScrollBarMiddle:Hide(); 
    
    CleanUI_RemoveTextures(MountJournal.MountCount);
    CleanUI_RemoveTextures(MountJournal.MountDisplay); 
    CleanUI_RemoveTextures(MountJournal.MountDisplay.ShadowOverlay); 
    CleanUI_RemoveTextures(MountJournal.LeftInset);   
    CleanUI_RemoveTextures(MountJournal.RightInset);  
    
    CleanUI_ChangeEditBox(MountJournalSearchBox, 32, -10, 5);
    MountJournalSearchBox:SetPoint("TOPLEFT", MountJournal.LeftInset, "TOPLEFT", 15, -5);
    
    CleanUI_ChangeButton(MountJournalMountButton);
end

function CleanUI_PetJournal_UseSafarihelm()	
	EquipItemByName(SAFARIHELM_ID);
end

function CleanUI_PetJournal_ShowKampfhaustierbandageTooltip()	
	GameTooltip:SetOwner(CUI_KampfhaustierbandageButton, "ANCHOR_RIGHT");
    local itemName, itemLink = GetItemInfo(KAMPFHAUSTIERBANDAGE_ID);
    GameTooltip:SetHyperlink(itemLink);
    GameTooltip:Show();
end

function CleanUI_PetJournal_ShowSafarihelmTooltip()	
	GameTooltip:SetOwner(CUI_SafarihelmButton, "ANCHOR_RIGHT");
    local itemName, itemLink = GetItemInfo(SAFARIHELM_ID);
    GameTooltip:SetHyperlink(itemLink);
    GameTooltip:Show();
end

function CleanUI_PetJournal_HideTooltip()	
    GameTooltip:FadeOut();
end

function CleanUI_PetJournal_BagUpdate()
	local itemCount;
	
	if (CUI_KampfhaustierbandageButton) then
		itemCount = GetItemCount(KAMPFHAUSTIERBANDAGE_ID);
		if (itemCount > 0) then
			CUI_KampfhaustierbandageButton:Show();
			CUI_KampfhaustierbandageButtonCount:SetText(""..itemCount);
		else
			CUI_KampfhaustierbandageButton:Hide();
		end
	end
	
	if (CUI_SafarihelmButton) then
		itemCount = GetItemCount(SAFARIHELM_ID);
		if (itemCount > 0) then
			CUI_SafarihelmButton:Show();
		else
			CUI_SafarihelmButton:Hide();
		end
	end
end

function CleanUI_PetJournal_UpdatePetList()	
	CleanUI_PetJournal_UpdatePetCount();
	CleanUI_PetJournal_UpdateCompanionListButtons();
	
	local scrollFrame = PetJournal.listScroll;
	local offset = HybridScrollFrame_GetOffset(scrollFrame);
	local petButtons = scrollFrame.buttons;
	local pet, index;
	
	local numPets, numOwned = C_PetJournal.GetNumPets();
	
	for i = 1,#petButtons do
		pet = petButtons[i];
		pet.name:SetWidth(125);
		
		if (not pet.cuihealth) then
			pet.cuihealth = CreateFrame("Frame", pet:GetName().."CUI_HEATH", pet, "CleanUIPetInfoHealthTemplate");
        	--pet.cuihealth:SetFrameStrata("MEDIUM"); 
        	pet.cuihealth:SetPoint("TOPRIGHT", pet, "TOPRIGHT", -10, -5);
        	pet.cuihealth:SetScale(0.75);
		end
		
		if (not pet.cuiexp) then
			pet.cuiexp = CreateFrame("StatusBar", pet:GetName().."CUI_EXP", pet, "CleanUIPetExpStatusBarTemplate");
        	--pet.cuiexp:SetFrameStrata("MEDIUM"); 
        	pet.cuiexp:SetPoint("BOTTOMLEFT", pet, "BOTTOMLEFT", 7, 4);
        	pet.cuiexp:SetPoint("BOTTOMRIGHT", pet, "BOTTOMRIGHT", -7, 4);
		end
		
		index = offset + i;
		if index <= numPets then
			local petID, speciesID, isOwned, customName, level, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet, canBattle = C_PetJournal.GetPetInfoByIndex(index);
			if isOwned then
				local health, maxHealth, attack, speed, rarity = C_PetJournal.GetPetStats(petID);
				local speciesID, customName, level, xp, maxXp, displayID, isFavorite, name, icon, petType, creatureID = C_PetJournal.GetPetInfoByPetID(petID);

        		pet.cuihealth:Show();
				pet.cuihealth.healthValue:SetFormattedText(PET_BATTLE_CURRENT_HEALTH_FORMAT, health, maxHealth);
				pet.cuihealth.healthBar:SetMinMaxValues(0, maxHealth);
				pet.cuihealth.healthBar:SetValue(health);
				
				if(level < 25) then
					pet.cuiexp:Show();
					pet.cuiexp:SetMinMaxValues(0, maxXp);
					pet.cuiexp:SetValue(xp);
				else
					pet.cuiexp:Hide();
				end
        	else        	
        		pet.cuihealth:Hide();
        		pet.cuiexp:Hide();
			end
		end
	end
end

function CleanUI_PetJournal_OnShow(self)
	-- load settings
	C_PetJournal.SetPetSortParameter(CleanUIPetJournal.sortParameter or LE_SORT_BY_NAME);
end

function CleanUI_PetJournal_OnHide(self)
	-- save settings
	CleanUIPetJournal.sortParameter = C_PetJournal.GetPetSortParameter();
end

function CleanUI_PetJournal_UpdatePetCount()
	local pets = {};
	local numUnique = 0;
	
	local numPets, numOwned = C_PetJournal.GetNumPets();
    
    local petID, speciesID, isOwned, customName, level, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet, canBattle;
    local health, maxHealth, attack, speed, rarity;
    for i = 1, numPets do
		petID, speciesID, isOwned, customName, level, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet, canBattle = C_PetJournal.GetPetInfoByIndex(i);
    	if (isOwned) then
			health, maxHealth, attack, speed, rarity = C_PetJournal.GetPetStats(petID);
			if (speciesID and not pets[speciesID]) then
				numUnique = numUnique + 1;
				pets[speciesID] = speciesID;
			end
		end
	end
	
	PetJournal.PetCount.Count:SetText(numOwned.." ("..numUnique..")");
end

function CleanUI_PetJournal_UpdateCompanionListButtons()
	local scrollFrame = PetJournal.listScroll;
	local offset = HybridScrollFrame_GetOffset(scrollFrame);
	local petButtons = scrollFrame.buttons;
	local pet, index;
	
	local numPets, numOwned = C_PetJournal.GetNumPets();
	
	local summonedPetID = C_PetJournal.GetSummonedPetGUID();

	local petID, speciesID, isOwned, customName, level, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet, canBattle;
	local health, maxHealth, attack, speed, rarity;
	local border;
	for i = 1,#petButtons do
		pet = petButtons[i];
		CleanUI_PetJournal_CreateButtonBorder(pet);
		index = offset + i;
		if index <= numPets then
			petID, speciesID, isOwned, customName, level, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet, canBattle = C_PetJournal.GetPetInfoByIndex(index);
			border = _G[pet:GetName().."CUI_Border"];
			
			if (isOwned) then
				health, maxHealth, attack, speed, rarity = C_PetJournal.GetPetStats(petID);
				pet.name:SetTextColor(ITEM_QUALITY_COLORS[rarity-1].r, ITEM_QUALITY_COLORS[rarity-1].g, ITEM_QUALITY_COLORS[rarity-1].b);
				border:SetVertexColor(ITEM_QUALITY_COLORS[rarity-1].r, ITEM_QUALITY_COLORS[rarity-1].g, ITEM_QUALITY_COLORS[rarity-1].b);
			else
				pet.name:SetTextColor(0.9, 0.9, 0.0);
				border:SetVertexColor(0.5, 0.5, 0.5);
			end
		end
	end
end

function CleanUI_PetJournal_CreateButtonBorder(button)
	button.iconBorder:Hide();
	button.icon:SetTexCoord(0.05, 0.95, 0.05, 0.95);
	
	local texture = _G[button:GetName().."CUI_Border"];
	
	if (not texture) then
		texture = button:CreateTexture(button:GetName().."CUI_Border", "ARTWORK");
	    texture:SetPoint("TOPLEFT", button.iconBorder, "TOPLEFT", -14, 14);
	    texture:SetPoint("BOTTOMRIGHT", button.iconBorder, "BOTTOMRIGHT", 14, -14);
        texture:SetTexture("Interface\\AddOns\\CleanUI\\skins\\bag\\item_border");
        texture:Show();
    end 
end
    
function CleanUI_InitPetBattleGroups()
    local groupButton = CreateFrame("Button", "CUIPetBattleGroupsButton", PetJournal, "UIPanelButtonTemplate");
    groupButton:SetWidth(120);
    groupButton:SetHeight(22);
    groupButton:SetPoint("TOPRIGHT", PetJournal, "TOPRIGHT", -6, -225);
    groupButton:SetText(GROUPS);
    groupButton:SetScript("OnClick", CleanUI_TogglePetBattleGroups);
    groupButton:SetFrameLevel(groupButton:GetFrameLevel() + 1);
    CleanUI_ChangeButton(groupButton); 
    
    local groupsFrame = CreateFrame("Frame", "CleanUIBattlePetGroupsFrame", PetJournal, "CleanUIBattlePetGroupsFrameTemplate");
    CleanUI_SetBackdrop(groupsFrame); 
    groupsFrame:SetSize(265, 606);
    groupsFrame:ClearAllPoints();
    groupsFrame:SetPoint("BOTTOMLEFT", PetJournal, "BOTTOMRIGHT", -2, 0);
    CleanUI_CreateHeaderFrame(groupsFrame, "CUI_BattlePetGroupsFrameHeaderBorderframe", 150, nil, GROUPS);
    CleanUI_ChangeCloseButton(groupsFrame);
    
    CleanUI_ChangeButton(CleanUIBattlePetGroupsFrameAddButton);
    CleanUI_ChangeButton(CleanUIBattlePetGroupsFrameSaveButton);
    CleanUI_ChangeButtonRed(CleanUIBattlePetGroupsFrameDeleteButton);

    -- create gui
	HybridScrollFrame_OnLoad(CleanUIBattlePetGroupsFrame.scrollFrame);
	CleanUIBattlePetGroupsFrame.scrollFrame.update = CleanUI_BattlePetGroups_OnUpdate;
	HybridScrollFrame_CreateButtons(CleanUIBattlePetGroupsFrame.scrollFrame, "CleanUIBattlePetGroupsEntryTemplate");
end
    
function CleanUI_TogglePetBattleGroups()
	if (CleanUIBattlePetGroupsFrame:IsVisible()) then
		CleanUIBattlePetGroupsFrame:Hide();
	else
		CleanUIBattlePetGroupsFrame:Show();
		CleanUI_BattlePetGroups_OnUpdate();
	end
end

function CleanUI_BattlePetGroups_OnUpdate()	
	if (not CleanUIBattlePetGroupsFrame) then
		return;
	end
	
	--update ui stats
	local groupsActive = 1;
	for p=1, MAX_ACTIVE_PETS do
		_, _, _, _, locked = C_PetJournal.GetPetLoadOutInfo(p);
		if (locked) then
			groupsActive = nil;
		end
	end
	
	if (groupsActive) then
		CUIPetBattleGroupsButton:Enable();
	else
		CUIPetBattleGroupsButton:Disable();
	end

	-- update group frame
	CleanUIBattlePetGroupsFrame.scrollFrame.highlightFrame:Hide();
	
	local buttons = CleanUIBattlePetGroupsFrame.scrollFrame.buttons;
	
	local numEntries = #CleanUIBattlePetGroups;
	local numButtons = #buttons;
		    
	local scrollOffset = HybridScrollFrame_GetOffset(CleanUIBattlePetGroupsFrame.scrollFrame);
	local buttonHeight = buttons[1]:GetHeight();
	local displayedHeight = 0;
	
	local entry;
	local data;
	
	for i=1, numButtons do	
		local entryIndex = i + scrollOffset;
		entry = buttons[i];
		
		if ( entryIndex <= numEntries ) then
		    data = CleanUIBattlePetGroups[entryIndex];
		    
			entry:Show();
		    entry.index = entryIndex;
		    
		    -- button data		    
            entry:SetText(data.name);
            
            -- pet data
            local id, health, maxHealth, power, speed, rarity;
            local speciesID, customName, level, xp, maxXp, displayID, isFavorite, name, icon, petType, creatureID, sourceText, description, isWild, canBattle, tradable, unique, obtainable;
            local pet;            
            for p=1, MAX_ACTIVE_PETS do
			    id = data.pet[p].petGUID;
			    health, maxHealth, power, speed, rarity = C_PetJournal.GetPetStats(id); 
			    speciesID, customName, level, xp, maxXp, displayID, isFavorite, name, icon, petType, creatureID, sourceText, description, isWild, canBattle, tradable, unique, obtainable = C_PetJournal.GetPetInfoByPetID(id) ;
            
            	pet = _G[entry:GetName().."Pet"..p];
            	
            	rarity = rarity or 1;
            
            	pet.PetInfo.icon:SetTexture(icon);
            	pet.PetInfo.qualityBorder:SetVertexColor(ITEM_QUALITY_COLORS[rarity-1].r, ITEM_QUALITY_COLORS[rarity-1].g, ITEM_QUALITY_COLORS[rarity-1].b);
            	pet.PetInfo.level:SetText(level);

				if (isFavorite) then
					pet.PetInfo.favorite:Show();
				else
					pet.PetInfo.favorite:Hide();
				end
				
				pet.PetInfo.typeIcon:SetTexture(GetPetTypeTexture(petType));	
				pet.PetInfo.isDead:SetShown((health or 0) <= 0);
				
				-- tooltip info					
				pet.speciesName = name;
				pet.sourceText = sourceText;
				pet.tradable = tradable;
				pet.unique = unique;

				if ( description and description ~= "" ) then
					pet.description = format([["%s"]], description);
				else
					pet.description = nil;
				end
            end
		    
            -- this isn't a header, hide the header textures
            entry:SetNormalTexture("");
            entry:SetHighlightTexture("");
            
            if (entryIndex == selectedIndex) then
                -- reposition highlight frames
                CleanUIBattlePetGroupsFrame.scrollFrame.highlightFrame:SetParent(entry);
                CleanUIBattlePetGroupsFrame.scrollFrame.highlightFrame:SetAllPoints(entry.name);
		        CleanUIBattlePetGroupsFrame.scrollFrame.highlightFrame:Show();
            end
		else
			entry:Hide();
		end
		
		displayedHeight = displayedHeight + buttonHeight;
	end
	
	HybridScrollFrame_Update(CleanUIBattlePetGroupsFrame.scrollFrame, numEntries * buttonHeight, displayedHeight);
end
    
function CleanUI_BattlePetGroupsPet_OnEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_BOTTOMRIGHT", 0, 0);
	GameTooltip:SetText(self.speciesName, 1, 1, 1);
	GameTooltip:AddLine(self.sourceText, 1, 1, 1, true);
	if ( not self.tradable ) then
		GameTooltip:AddLine(BATTLE_PET_NOT_TRADABLE, 1, 0.1, 0.1, true);
	end
	if ( self.unique ) then
		GameTooltip:AddLine(ITEM_UNIQUE, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, true);
	end
	if ( self.description and self.description ~= "" ) then
		GameTooltip:AddLine(" ");
		GameTooltip:AddLine(self.description, nil, nil, nil, true);
	end
	GameTooltip:Show();
end
    
function CleanUI_BattlePetGroupsPet_OnLeave(self) 
    GameTooltip:FadeOut();
end
    
function CleanUI_BattlePetGroupsEntry_OnClick(self, button, down)
    PlaySound("ACTIONBARBUTTONDOWN");
    selectedIndex = self.index;
    CleanUI_BattlePetGroups_OnUpdate();
    
    local data = CleanUIBattlePetGroups[selectedIndex];
    
	if (button == "LeftButton") then
    elseif (button == "RightButton") then
	    local dialog = StaticPopup_Show("CUI_BATTLEPET_GROUPS_RENAME_TITLE_POPUP");
	    local editbox = _G[dialog:GetName().."EditBox"];
	    editbox:SetText(data.name or "");
    end
end
    
function CleanUI_BattlePetGroupsEntry_OnDoubleClick(self)
	if (not selectedIndex or selectedIndex > #CleanUIBattlePetGroups) then
		return;
	end
	
	local data = CleanUIBattlePetGroups[selectedIndex];
	
	for i=1, MAX_ACTIVE_PETS do
		C_PetJournal.SetPetLoadOutInfo(i, data.pet[i].petGUID);
		C_PetJournal.SetAbility(i, 1, data.pet[i].ability1);
		C_PetJournal.SetAbility(i, 2, data.pet[i].ability2);
		C_PetJournal.SetAbility(i, 3, data.pet[i].ability3);
	end
	
	PetJournal_UpdateAll();
end
 
function CleanUI_BattlePetGroups_ResetSelection()   
    selectedIndex = nil;
end
    
function CleanUI_AddPetBattleGroup()
    local dialog = StaticPopup_Show("CUI_BATTLEPET_GROUPS_ADD_TITLE_POPUP");    
    local editbox = _G[dialog:GetName().."EditBox"];
    editbox:SetText("");
end
    
function CleanUI_AddPetBattleGroupWithName(name)	
	local data = {};
	data.pet = {};
	
	data.name = name;
	
	CleanUI_UpdateBattlePetGroupData(data);
	
	tinsert(CleanUIBattlePetGroups, data);
	
    CleanUI_BattlePetGroups_OnUpdate();
end
    
function CleanUI_RenamePetBattleGroupWithName(name)
	if (not selectedIndex or selectedIndex > #CleanUIBattlePetGroups) then
		return;
	end
	
	local data = CleanUIBattlePetGroups[selectedIndex];
	
	data.name = name;

    CleanUI_BattlePetGroups_OnUpdate();
end
    
function CleanUI_SavePetBattleGroup()
	if (not selectedIndex or selectedIndex > #CleanUIBattlePetGroups) then
		return;
	end
	
	local data = CleanUIBattlePetGroups[selectedIndex];
	
	CleanUI_UpdateBattlePetGroupData(data);
	
    CleanUI_BattlePetGroups_OnUpdate();
end
    
function CleanUI_DeletePetBattleGroup()
	if (not selectedIndex or selectedIndex > #CleanUIBattlePetGroups) then
		return;
	end
	
	tremove(CleanUIBattlePetGroups, selectedIndex);

	CleanUI_BattlePetGroups_ResetSelection();
    CleanUI_BattlePetGroups_OnUpdate();
end

    
function CleanUI_UpdateBattlePetGroupData(data)
	local petGUID, ability1, ability2, ability3, locked;
	local petdata;
	for i=1, 3 do
		petGUID, ability1, ability2, ability3, locked = C_PetJournal.GetPetLoadOutInfo(i);
		data.pet[i] = {petGUID = petGUID, ability1 = ability1, ability2 = ability2, ability3 = ability3};
	end
end
