function CleanUI_InitQuestFrame()
    for i = 1, 10 do
        local questItem = _G["QuestInfoItem"..i];
        local questItemName = _G["QuestInfoItem"..i.."Name"];
        local questItemNameFrame = _G["QuestInfoItem"..i.."NameFrame"];
        
        questItemName:SetFontObject("GameFontHighlightSmall");	
        questItemName:ClearAllPoints(); 
        questItemName:SetPoint("LEFT", questItemNameFrame, "LEFT", 15, 5);
        
        --party pet name
        local price = questItem:CreateFontString("CUI_QuestItem"..i.."Price", "ARTWORK");
        price:SetFontObject("GameFontNormalSmall");
        price:ClearAllPoints(); 
        price:SetPoint("BOTTOMRIGHT", questItemNameFrame, "BOTTOMRIGHT", -15, 15);
        price:SetJustifyH("RIGHT");
        price:SetText("");
    end
    
    CleanUI_QuestFrameHookEvents();
    CleanUI_RegisterQuestFrameEvents();
    
    CleanUI_CleanQuestLogFrame();
    CleanUI_CleanQuestLogDetailFrame();
    CleanUI_CleanQuestFrame();
    CleanUI_CleanQuestGreetingFrame();
    CleanUI_CleanLootFrame();
    
    CleanUI_UpdateWatchFrameAlpha();
end
    
function CleanUI_UpdateWatchFrameAlpha()
    WatchFrame:SetAlpha(CleanUIData.WATCHFRAME_ALPHA);
end
    
function CleanUI_RegisterQuestFrameEvents()         
    local frame = CreateFrame("Frame");
    
    --frame:RegisterEvent("");
    
    frame:HookScript("OnEvent", CleanUI_QuestFrameOnEvent); 
end

function CleanUI_QuestFrameOnEvent(self, event, ...)
end

function CleanUI_QuestFrameHookEvents()
    hooksecurefunc("QuestInfo_Display", CleanUI_LoadQuestItemInfo);
	
	hooksecurefunc("QuestLog_Update", CleanUI_UpdateQuestInfo);
	hooksecurefunc(QuestLogScrollFrame, "update", CleanUI_UpdateQuestInfo);
end
    
function CleanUI_CleanQuestLogFrame()  
    CleanUI_RemoveTextures(QuestLogFrame); 
    CleanUI_SetBackdrop(QuestLogFrame);
    
    QuestLogFramePortrait:Hide();
    
    CleanUI_ChangeCloseButton(QuestLogFrame);   
    
    CleanUI_CreateHeaderFrame(QuestLogFrame, "CUI_QuestLogFrameHeaderBorderframe", 250, QuestLogTitleText);  
    
    CleanUI_RemoveTextures(QuestLogCount);
    
    CleanUI_RemoveTextures(EmptyQuestLogFrame);  
    
    CleanUI_RemoveTextures(QuestLogFrameInset);
    
    CleanUI_RemoveTextures(QuestLogScrollFrame); 
    CleanUI_RemoveTextures(QuestLogDetailScrollFrame);
    
    local background = QuestLogFrame:CreateTexture("CUI_QuestLogFrameBackground", "BORDER");
    background:ClearAllPoints();
    background:SetPoint("TOPRIGHT", QuestLogFrame, "TOPRIGHT", -28, -60);
    background:SetSize(308, 412);
    background:SetTexture("interface\\Addons\\CleanUI\\skins\\frame\\paper-background");

    CleanUI_ChangeButtonRed(QuestLogFrameAbandonButton);
    CleanUI_ChangeButton(QuestLogFramePushQuestButton);
    CleanUI_ChangeButton(QuestLogFrameTrackButton);
    CleanUI_ChangeButtonRed(QuestLogFrameCancelButton);
    CleanUI_ChangeButton(QuestLogFrameCompleteButton);
end
    
function CleanUI_CleanQuestLogDetailFrame()  
    CleanUI_RemoveTextures(QuestLogDetailFrame); 
    CleanUI_SetBackdrop(QuestLogDetailFrame);
    
    CleanUI_ChangeCloseButton(QuestLogDetailFrame);
    
    CleanUI_CreateHeaderFrame(QuestLogDetailFrame, "CUI_QuestLogDetailFrameHeaderBorderframe", 250, QuestLogDetailTitleText);  
    
    local background = QuestLogDetailFrame:CreateTexture("CUI_QuestLogDetailFrameBackground", "BORDER");
    background:ClearAllPoints();
    background:SetPoint("TOPLEFT", QuestLogDetailFrame, "TOPLEFT", 3, -60);
    background:SetSize(308, 412);
    background:SetTexture("interface\\Addons\\CleanUI\\skins\\frame\\paper-background");
    
    CleanUI_RemoveTextures(QuestLogDetailFrameInset);    
end
    
function CleanUI_CleanQuestFrame()  
    CleanUI_RemoveTextures(QuestFrame); 
    CleanUI_SetBackdrop(QuestFrame);
    
    QuestFramePortrait:Hide();  
    
    CleanUI_ChangeCloseButton(QuestFrame);
    
    CleanUI_CreateHeaderFrame(QuestFrame, "CUI_QuestFrameHeaderBorderframe", 250, QuestFrameNpcNameText);  
    
    local background = QuestFrame:CreateTexture("CUI_QuestFrameBackground", "BORDER");
    background:ClearAllPoints();
    background:SetPoint("TOPLEFT", QuestFrame, "TOPLEFT", 3, -60);
    background:SetSize(308, 412);
    background:SetTexture("interface\\Addons\\CleanUI\\skins\\frame\\paper-background");
          
    CleanUI_RemoveTextures(QuestFrameInset);     
    
    CleanUI_RemoveTextures(QuestDetailScrollFrame); 
    CleanUI_RemoveTextures(QuestFrameDetailPanel); 
    
    CleanUI_RemoveTextures(QuestProgressScrollFrame); 
    CleanUI_RemoveTextures(QuestFrameProgressPanel); 
    
    CleanUI_ChangeButton(QuestFrameAcceptButton);
    CleanUI_ChangeButton(QuestFrameDeclineButton);
    CleanUI_ChangeButton(QuestFrameCompleteButton);
    CleanUI_ChangeButtonRed(QuestFrameGoodbyeButton);   
    
    CleanUI_RemoveTextures(QuestFrameRewardPanel);
    
    QuestRewardScrollFrameTop:Hide();
    QuestRewardScrollFrameMiddle:Hide();
    QuestRewardScrollFrameBottom:Hide();   
    
    CleanUI_ChangeButton(QuestFrameCompleteQuestButton);
end
    
function CleanUI_CleanLootFrame()         
    CleanUI_RemoveTextures(LootFrame); 
    CleanUI_SetBackdrop(LootFrame);
    
    LootFramePortraitOverlay:Hide(); 
    
    CleanUI_ChangeCloseButton(LootFrame);      
    
    LootFrameTitleText:Hide();
    local headerText = CleanUI_GetRegionOfTypeAtPos(LootFrame, "FontString", 0);
    CleanUI_CreateHeaderFrame(LootFrame, "CUI_LootFrameHeaderBorderframe", 115, headerText);  
    
    CleanUI_RemoveTextures(LootFrameInset); 
    CleanUI_RemoveTextures(LootButton1);    
    CleanUI_RemoveTextures(LootButton2);    
    CleanUI_RemoveTextures(LootButton3);    
    CleanUI_RemoveTextures(LootButton4); 
end
    
function CleanUI_CleanQuestGreetingFrame()     
    CleanUI_RemoveTextures(QuestFrameGreetingPanel); 
    
    QuestGreetingScrollFrameTop:Hide();
    QuestGreetingScrollFrameMiddle:Hide();
    QuestGreetingScrollFrameBottom:Hide();  
    
    CleanUI_ChangeButton(QuestFrameGreetingGoodbyeButton);  
end

function CleanUI_LoadQuestItemInfo()	
    for i = 1, 10 do
        local questItem = _G["QuestInfoItem"..i];
        local questItemPrice = _G["CUI_QuestItem"..i.."Price"];
        
        if (questItemPrice) then
            questItemPrice:SetText(ITEM_UNSELLABLE);
            
            if (questItem.objectType == "item" and questItem:IsVisible()) then
        
                local itemLink;
            
                if (QuestInfoFrame.questLog) then
                    itemLink = GetQuestLogItemLink(questItem.type, i);
                else
                    itemLink = GetQuestItemLink(questItem.type, i);
                end
                        
                if (itemLink) then
                    local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemLink);
    
                    local moneyString = ITEM_UNSELLABLE;
                    if (itemSellPrice and itemSellPrice > 0) then
                        moneyString = "|cffffffff"..GetCoinTextureString(itemSellPrice).."|r";
                    end
                    
                    questItemPrice:SetText(moneyString);
                end
            end
        end
    end
end

function CleanUI_UpdateQuestInfo()

    local buttons = QuestLogScrollFrame.buttons;
    
    local scrollOffset = HybridScrollFrame_GetOffset(QuestLogScrollFrame);
    local numEntries = GetNumQuestLogEntries();
    local questIndex, questLogTitle;
    local questLogTitleText, level, isHeader, _;
    
    local tag_format = " [%s] %s";
    
    for i=1, #buttons do
    
        questIndex = i + scrollOffset;
        questLogTitle = buttons[i];
        questNormalText = questLogTitle.normalText;
		--questTitleTag = questLogTitle.tag;
        
        if questIndex <= numEntries then
            questLogTitleText, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, questID = GetQuestLogTitle(questIndex);
            
            if (not isHeader) and questLogTitleText then
            
            	local info = ""..level;
	
				if (suggestedGroup > 0) then
					info = info.."G"..suggestedGroup;
				end
            
                local text = tag_format:format(info, questLogTitleText);
                
                if (isComplete or numObjectives == 0) then
                	text = "|cff3399ff"..text.."|r";
                else                
                    -- difficulty
                    if ( MAP_QUEST_DIFFICULTY == "1" ) then
                        local color = GetQuestDifficultyColor(level);
                        local hex = cui_rgb2hex(color.r, color.g, color.b);
                        
                        text = "|cff"..hex..text.."|r";
                    end
                end
                
                questLogTitle:SetText(text);
                QuestLogTitleButton_Resize(questLogTitle);
            end
        end
    end
end