function CleanUI_InitRoleCheck()
    CleanUI_RoleCheckHookEvents();
    CleanUI_RegisterRoleCheckEvents();
end
    
function CleanUI_RegisterRoleCheckEvents()
    local frame = CreateFrame("Frame");
    
    frame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED"); 
    frame:RegisterEvent("GROUP_ROSTER_UPDATE"); 
    
    frame:HookScript("OnEvent", CleanUI_RoleCheckOnEvent); 
end

function CleanUI_RoleCheckOnEvent(self, event, ...)
    if (event == "ACTIVE_TALENT_GROUP_CHANGED" or event == "GROUP_ROSTER_UPDATE") then
        CleanUI_UpdateRole();
    end
end

function CleanUI_RoleCheckHookEvents()
    -- close popup immediatelly
    RolePollPopup:SetScript("OnShow",function() CleanUI_RolePoll() end);
end

function CleanUI_RolePoll()
    local selected = CleanUI_UpdateRole();
    
    if (selected) then
        RolePollPopupAcceptButton:Click();
    end
end

function CleanUI_UpdateRole()  
    if (InCombatLockdown()) then
        return;
    end
        
    local activeSpecGroup = GetActiveSpecGroup(false);    
    local primaryTree = GetSpecialization(false, false, activeSpecGroup);
    
    if (primaryTree) then
        local id, name, description, icon, background, role = GetSpecializationInfo(primaryTree);    
        UnitSetRole("player", role);
        
        return true;
    end
    
    return false;
end