

function CleanUI_InitSpellBookFrame()    
    CleanUI_SpellBookFrameHookEvents();
    CleanUI_RegisterSpellBookFrameEvents();
    
    CleanUI_CleanSpellBookFrame();
end
    
function CleanUI_RegisterSpellBookFrameEvents()
    --local frame = CreateFrame("Frame");
    
    --frame:RegisterEvent("---");
    
    --frame:HookScript("OnEvent", CleanUI_SpellBookFrameOnEvent); 
end

function CleanUI_SpellBookFrameHookEvents()
    hooksecurefunc("SpellBookFrame_UpdateSkillLineTabs", CleanUI_SpellBookFrame_UpdateSkillLineTabs);
    hooksecurefunc("SpellBookCoreAbilities_UpdateTabs", CleanUI_SpellBookCoreAbilities_UpdateTabs);
end

function CleanUI_SpellBookFrameOnEvent(self, event, ...)
    if (event == "---") then
    end
end
    
function CleanUI_CleanSpellBookFrame()
    CleanUI_RemoveTextures(SpellBookFrame);  
    CleanUI_SetBackdrop(SpellBookFrame); 
    
    CleanUI_RemoveTextures(SpellBookFrameInset); 
    
    CleanUI_ChangeCloseButton(SpellBookFrame); 
    
    local header = CleanUI_CreateHeaderFrame(SpellBookFrame, "CUI_SpellBookFrameHeaderBorderframe", 250, SpellBookFrameTitleText);
    
    SpellBookFrameTutorialButton.Ring:Hide();    
    SpellBookFrameTutorialButton:Hide();
    
    SpellBookPage1:Hide();
    SpellBookPage2:Hide();
    
    local tabButton;
    for i=1, 10 do
        tabButton = _G["SpellBookFrameTabButton"..i];
        if (not tabButton) then
            break;
        end
        
        CleanUI_ChangeTab(tabButton);
    end
        
    SpellBookFrameTabButton1:ClearAllPoints();
    SpellBookFrameTabButton1:SetPoint("TOPLEFT", SpellBookFrame, "BOTTOMLEFT", 0, 2);
    
    local sideTabButton;
    for i=1, 10 do
        sideTabButton = _G["SpellBookSkillLineTab"..i];
        if (not sideTabButton) then
            break;
        end
        
        CleanUI_SpellBookChangeSideTab(sideTabButton);
    end
    
    for i=1, 10 do
		sideTabButton = SpellBook_GetCoreAbilitySpecTab(i);
        if (sideTabButton) then
        	CleanUI_SpellBookChangeSideTab(sideTabButton);
        end
    end
    
    CleanUI_ChangeNextButton(SpellBookNextPageButton);
    CleanUI_ChangeBackButton(SpellBookPrevPageButton);
    
    local background = SpellBookFrame:CreateTexture("CUI_SpellBookFrameBackground", "BORDER");
    background:ClearAllPoints();
    background:SetPoint("TOPLEFT", SpellBookFrame, "TOPLEFT", 10, -20);
    background:SetSize(525, 495);
    background:SetTexture("interface\\Addons\\CleanUI\\skins\\frame\\paper-background");
    
    PrimaryProfession1.icon:SetBlendMode("DISABLE");
    PrimaryProfession2.icon:SetBlendMode("DISABLE");
    
    PrimaryProfession1SpellButtonTopNameFrame:SetTexture("Interface\\Spellbook\\Spellbook-Parts");
    PrimaryProfession1SpellButtonTopNameFrame:SetTexCoord(0.31250000, 0.96484375, 0.37109375, 0.52343750);
    PrimaryProfession1SpellButtonBottomNameFrame:SetTexture("Interface\\Spellbook\\Spellbook-Parts");
    PrimaryProfession1SpellButtonBottomNameFrame:SetTexCoord(0.31250000, 0.96484375, 0.37109375, 0.52343750);
    PrimaryProfession2SpellButtonTopNameFrame:SetTexture("Interface\\Spellbook\\Spellbook-Parts");
    PrimaryProfession2SpellButtonTopNameFrame:SetTexCoord(0.31250000, 0.96484375, 0.37109375, 0.52343750);
    PrimaryProfession2SpellButtonBottomNameFrame:SetTexture("Interface\\Spellbook\\Spellbook-Parts");
    PrimaryProfession2SpellButtonBottomNameFrame:SetTexCoord(0.31250000, 0.96484375, 0.37109375, 0.52343750);
    
    SecondaryProfession1SpellButtonLeftNameFrame:SetTexture("Interface\\Spellbook\\Spellbook-Parts");
    SecondaryProfession1SpellButtonLeftNameFrame:SetTexCoord(0.31250000, 0.96484375, 0.37109375, 0.52343750);
    SecondaryProfession1SpellButtonRightNameFrame:SetTexture("Interface\\Spellbook\\Spellbook-Parts");
    SecondaryProfession1SpellButtonRightNameFrame:SetTexCoord(0.31250000, 0.96484375, 0.37109375, 0.52343750);
    SecondaryProfession2SpellButtonLeftNameFrame:SetTexture("Interface\\Spellbook\\Spellbook-Parts");
    SecondaryProfession2SpellButtonLeftNameFrame:SetTexCoord(0.31250000, 0.96484375, 0.37109375, 0.52343750);
    SecondaryProfession2SpellButtonRightNameFrame:SetTexture("Interface\\Spellbook\\Spellbook-Parts");
    SecondaryProfession2SpellButtonRightNameFrame:SetTexCoord(0.31250000, 0.96484375, 0.37109375, 0.52343750);
    SecondaryProfession3SpellButtonLeftNameFrame:SetTexture("Interface\\Spellbook\\Spellbook-Parts");
    SecondaryProfession3SpellButtonLeftNameFrame:SetTexCoord(0.31250000, 0.96484375, 0.37109375, 0.52343750);
    SecondaryProfession3SpellButtonRightNameFrame:SetTexture("Interface\\Spellbook\\Spellbook-Parts");
    SecondaryProfession3SpellButtonRightNameFrame:SetTexCoord(0.31250000, 0.96484375, 0.37109375, 0.52343750);
    SecondaryProfession4SpellButtonLeftNameFrame:SetTexture("Interface\\Spellbook\\Spellbook-Parts");
    SecondaryProfession4SpellButtonLeftNameFrame:SetTexCoord(0.31250000, 0.96484375, 0.37109375, 0.52343750);
    SecondaryProfession4SpellButtonRightNameFrame:SetTexture("Interface\\Spellbook\\Spellbook-Parts");
    SecondaryProfession4SpellButtonRightNameFrame:SetTexCoord(0.31250000, 0.96484375, 0.37109375, 0.52343750);
    
    SpellBookFrame_Update();
end

function CleanUI_SpellBookChangeSideTab(tabButton)
    CleanUI_RemoveTextures(tabButton);
    
    local name = tabButton:GetName();
    
    local borderframe;
    
    if (name) then
	    borderframe = _G[name.."Borderframe"];
	    if (not borderframe) then
	        borderframe = CreateFrame("Frame", name.."Borderframe", tabButton);
	    end
    else
    	borderframe = CreateFrame("Frame");
    	borderframe:SetParent(tabButton);
    end
    
    borderframe:ClearAllPoints();
    borderframe:SetPoint("TOPLEFT", tabButton, "TOPLEFT", -4, 4);
    borderframe:SetPoint("BOTTOMRIGHT", tabButton, "BOTTOMRIGHT", 3, -4);
    
    borderframe:SetFrameStrata("LOW");
    
    borderframe:SetBackdrop( { 
        bgFile = CUI_TAB_BACKGROUND_RIGHT, 
        edgeFile = border, tile = true, tileSize = 64, edgeSize = 16, 
        insets = { left = insetValue, right = insetValue, top = insetValue, bottom = insetValue }
    }); 
    
    tabButton:SetNormalTexture(nil);
    tabButton:SetPushedTexture(nil);
    tabButton:SetHighlightTexture(nil);
    
    local checkedTexture = tabButton:GetCheckedTexture();
    checkedTexture:ClearAllPoints();
    checkedTexture:SetPoint("TOPLEFT", borderframe, "TOPLEFT", 0, 0);
    checkedTexture:SetPoint("BOTTOMRIGHT", borderframe, "BOTTOMRIGHT", 0, 0);
    tabButton:SetCheckedTexture("Interface\\AddOns\\CleanUI\\skins\\highlight");
end

function CleanUI_SpellBookFrame_UpdateSkillLineTabs()
    local numSkillLineTabs = GetNumSpellTabs();
    local skillLineTab, texture;
    for i=1, MAX_SKILLLINE_TABS do
        skillLineTab = _G["SpellBookSkillLineTab"..i];
        
        texture = skillLineTab:GetNormalTexture();
        
        if (texture) then
            texture:SetTexCoord(0.1, 0.9, 0.1, 0.9);
        end
    end
end

function CleanUI_SpellBookCoreAbilities_UpdateTabs()
    local texture;
    for i=1, 10 do
		tab = SpellBook_GetCoreAbilitySpecTab(i);
        
        texture = tab:GetNormalTexture();
        
        if (texture) then
            texture:SetTexCoord(0.1, 0.9, 0.1, 0.9);
        end
	end
end
